
# topology file:  lmstest.t

#--------------------------------------------------- 
# Title: LMS Test using unnormalized LMS Algorithm       
# Author:  
# Date:  
# Description: System Identification       
#--------------------------------------------------- 

inform title LMS Test using unnormalized LMS Algorithm      
inform author 
inform date 
inform descrip System Identification      

arg -1 (none)

param int 500    num_of_samples   "total number of samples to output"
param float 1    dev   "Noise Standard Deviation"
param int 3759    seed   "Seed for random number generator"
param float 1    pace_rate   "pace rate to determine how many samples to output"
param int 128    samples_first_time   "number of samples on the first call if paced"
block gauss0 gauss

block node0 node

param file imp.dat    filename   "File name containing impulse response samples"
param int 8    N   "Order of impulse response"
block convolve0 convolve

block node1 node

param int 10    N   "Filter order"
param float 0.1    mu   "LMS gain constant"
param int 0    outputFlag   "Flag: 0=estimate, 1=error"
block lms0 lms

param array 2  1  -1    weights   "Array of weights: number_of_weights w0 w1 w2 ... "
block sum0 sum

param int 500    npts   "Number of points in each plot (dynamic window size)"
param int 0    skip   "Points to skip before first plot"
param file lmserror    title   "Plot title"
param file X    x_axis   "X Axis label"
param file Y    y_axis   "Y-Axis label"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    mode   "0=Static,1=Dynamic"
param int 1    samplingRate   "Sampling Rate"
block xplot0 plot

block sink0 sink

connect gauss0 0 node0 0  	{gauss0:NULL:NULL,node0:x:float}
connect node0 0 convolve0 0  	{node0:NULL:NULL,convolve0:x:float}
connect node0 1 lms0 0  	{node0:NULL:NULL,lms0:z:float}
connect convolve0 0 node1 0  	{convolve0:y:float,node1:x:float}
connect node1 0 lms0 1  	{node1:NULL:NULL,lms0:x:float}
connect node1 1 sum0 0  	
connect lms0 0 sum0 1  	
connect sum0 0 xplot0 0  	
connect xplot0 0 sink0 0  	

