
# topology file:  predftftest.t

#--------------------------------------------------- 
# Title: Fast Transversal Filter (RLS) Adaptive Filter              
# Author: Sasan Ardalan               
# Date:  
# Description: System Identification                
#--------------------------------------------------- 

inform title Fast Transversal Filter (RLS) Adaptive Filter             
inform author Sasan Ardalan              
inform date 
inform descrip System Identification               

arg -1 (none)

param int 1000    num_of_samples   "total number of samples to output"
param float 1    dev   "Noise Standard Deviation"
param int 3759    seed   "Seed for random number generator"
param float 1    pace_rate   "pace rate to determine how many samples to output"
param int 128    samples_first_time   "number of samples on the first call if paced"
block gauss0 gauss

block node0 node

param file imp.dat    filename   "File name containing impulse response samples"
param int 8    N   "Order of impulse response"
block convolve0 convolve

param array 2  1  -1    weights   "Array of weights: number_of_weights w0 w1 w2 ... "
block sum0 sum

param file prfile    ifile_name   " Name of ASCII input specification file"
param file prfileo    ofile_name   " Name of ASCII output specification file"
param float 1    lambda   "Forgetting factor <= 1.0"
param float 0.0001    delta   "Initial value: forward prediction energy value"
param int 0    wait   " Number of samples to skip before starting adaptation"
param int -1    adapt   " Number of samples to adapt.Freeze after this number of iterations"
block predftf0 predftf

param int 256    npts   "Number of points in each plot (dynamic window size)"
param int 0    skip   "Points to skip before first plot"
param file Error    title   "Plot title"
param file X    x_axis   "X Axis label"
param file Y    y_axis   "Y-Axis label"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    mode   "0=Static,1=Dynamic"
param int 1    samplingRate   "Sampling Rate"
block xplot0 plot

block sink0 sink

connect gauss0 0 node0 0  	{gauss0:NULL:NULL,node0:x:float}
connect node0 0 convolve0 0  	{node0:NULL:NULL,convolve0:x:float}
connect node0 1 predftf0 1  	
connect convolve0 0 sum0 0  	
connect sum0 0 xplot0 0  	
connect sum0 1 predftf0 0  	
connect predftf0 0 sum0 1  	
connect xplot0 0 sink0 0  	

