/* lmsgauss2d.s */
/***********************************************************************

                             lmsgauss2d()

************************************************************************

Date:  July 9, 1990 
Programmer: Karaoguz, Jeyhan 

*/

#include <stdio.h>
#define EE 2.7182818
#define big 21474836480.0


parameters
	param_def = "Filter order";
        int N = 8 ;
        param_def = "Initial step size";
        float   mu=0.009;
        param_def = "step size update ratio";
        float   muratio=1.0;
        param_def = "step size update rate (in samples)";
        int   murate=4000;
        param_def = "variance update ratio";
        float   varratio=1.0;
        param_def = "variance update rate (in samples)";
        int   varrate=4000;
        param_def="mean";
        float mean = 1.0 ;
        param_def="variance";
        float var = 0.14;
        param_def = "Flag: 0=estimate, 1=error";
        int     outputFlag=0;
 	param_def = "initilization";
        float init = 1.0;
end

states
	float** x_P;	/* freq. response of nyquist filter */
	float** w_P;
        int mucounter;
        int varcounter;
	float tmpvar;
	float tmpmu;
end

declarations
   	int i;
   	int j, k;
        float register1[2];
        float register2[2];
        float output[2];
        float lambda11=0.0, lambda21=0.0, lambda22=0.0, lambda12=0.0;
        float xtemp=0.0, ytemp=0.0;
	FILE *fopen();
	FILE *imp_F;
	FILE *imp;
	FILE *imp_W;
end

initialization_code
           
	/*
	 * Allocate memory and return pointers for tapped delay line x_P and
	 * array containing impulse response samples, h_P.
	 *
	 */
	if( (x_P = (float**)calloc(2,4)) == NULL ||
	    (w_P = (float**)calloc(2,4)) == NULL ) {
	   	fprintf(stderr,"convolve: can't allocate work space\n");
		return(4);
	}
        for(i=0; i<2; i++)
	if( (x_P[i] = (float*)calloc(N,4)) == NULL ||
	    (w_P[i] = (float*)calloc(N,4)) == NULL ) {
	   	fprintf(stderr,"convolve: can't allocate work space\n");
		return(4);
	}

	/*
	 * Read in the impulse response samples into the array
	 * and initialize the tapped delay line to zero.
         * According to this for loop the impulse data is assumed to be
         * in the order of first real then imaginary value for each tap
         *
         */
	tmpvar = var;
	tmpmu = mu;
	mucounter = 0;
	varcounter = 0;
	
	    w_P[0][0] = init;
      for(j=1;j<N;j++)
	    w_P[0][j] = 0.0;
      for(j=0;j<N;j++)
	    w_P[1][j] = 0.0; 

      for(j=0;j<N;j++)
         for(i=0;i<2;i++){
            x_P[i][j] = 0.0; } 

end
 
main_code



	while(it_in(0) && it_in(1)){
		/*
		 * Shift input samples into tapped delay line
		 */  
		mucounter++ ; 
		varcounter++ ; 
                for( i=0 ; i<2 ; i++)
		register2[i] = inf(i,0);

		for(i=0; i<N; i++) 
                    for(j=0; j<2; j++){
			register1[j] = x_P[j][i];
			x_P[j][i] = register2[j];
			register2[j] = register1[j];
		}
		/*
		 * Compute inner product 
		 */
                output[0] = 0.0;
                output[1] = 0.0;
		for (i=0; i<N; i++) { 
		     output[0] += ( x_P[0][i]*w_P[0][i] -
                                          x_P[1][i]*w_P[1][i]);
		     output[1] += ( x_P[0][i]*w_P[1][i] +
                                          x_P[1][i]*w_P[0][i]);
		}

                for(i=0; i<2; i++) {
                        it_out(i);
                        outf(i,0) = output[i];
                }



	 	xtemp = 2.0*mean*output[0]/tmpvar;
		ytemp = 2.0*mean*output[1]/tmpvar; 
		lambda11 = 1.0/((1.0+pow(EE,-xtemp))*(1.0+pow(EE,-ytemp)));
		lambda21 = 1.0/((1.0+pow(EE,xtemp))*(1.0+pow(EE,-ytemp)));
		lambda22 = 1.0/((1.0+pow(EE,xtemp))*(1.0+pow(EE,ytemp)));
		lambda12 = 1.0/((1.0+pow(EE,-xtemp))*(1.0+pow(EE,ytemp)));

		if(mucounter == murate) {
			tmpmu = muratio*tmpmu;
			mucounter = 0;
					}
		if(varcounter == varrate) {
			tmpvar = varratio*tmpvar;
			varcounter = 0;
					}

                for (i=0;i<N;i++) { 

		 w_P[0][i] += tmpmu*(1.0/tmpvar)*(lambda11*((mean-output[0])*x_P[0][i]+(mean - output[1])*x_P[1][i])+lambda21*((-mean-output[0])*x_P[0][i]+(mean-output[1])*x_P[1][i])+lambda22*((-mean-output[0])*x_P[0][i]+(-mean-output[1])*x_P[1][i])+lambda12*((mean-output[0])*x_P[0][i]+(-mean-output[1])*x_P[1][i]));

                 w_P[1][i] += tmpmu*(1.0/tmpvar)*(lambda11*((output[0]-mean)*x_P[1][i]+(mean-output[1])*x_P[0][i])+lambda21*((output[0]+mean)*x_P[1][i]+(mean-output[1])*x_P[0][i])+lambda22*((output[0]+mean)*x_P[1][i]+(-mean-output[1])*x_P[0][i])+lambda12*((output[0]-mean)*x_P[1][i]+(-mean-output[1])*x_P[0][i]));
                                     } 

}
imp_W = fopen("taps","w");
      for(j=0;j<N;j++)
         for(i=0;i<2;i++){
            fprintf(imp_W,"%f\n", w_P[i][j]);
                           } 
fclose(imp_W);
              
end

wrapup_code

	free(x_P); free(w_P);
end
