
# topology file:  blindeqdynamic.t

#--------------------------------------------------- 
# Title:  
# Author:  
# Date:  
# Description:  
#--------------------------------------------------- 

inform title 
inform author 
inform date 
inform descrip 

arg 0 int 11 "delay"
arg 1 float 0.75 "lpcf"

param int 10000    num_of_samples   "total number of samples to output"
param int 1468    initialize   "Initialization for shift register"
param float 1    pace_rate   "pace rate to determine how many samples to output"
param int 128    samples_first_time   "number of samples on the first call if paced"
block bdata0 bdata

param int 2    N   "Ratio input rate/output rate,N"
param array 2  0  1    phases   "Array: Specifies the phase (delay in samples relative to first input sample) for each output."
block demux0 demux

param int 0    code_type   "Code type:0-Binary(NRZ),1-Biphase(Manchester),2-2B1Q,3-RZ-AMI(Alternate mark inversion)"
param int 8    smplbd   "Samples per baud"
block linecode0 linecode

param int 0    code_type   "Code type:0-Binary(NRZ),1-Biphase(Manchester),2-2B1Q,3-RZ-AMI(Alternate mark inversion)"
param int 8    smplbd   "Samples per baud"
block linecode1 linecode

param int 8    smplbd   "samples per baud interval."
param int 8    expfft   "expfft: 2^expfft=fft length to use."
param float 0.25    beta   "beta: filter rolloff factor, 0<beta<=.5 "
block sqrtnyq1 sqrtnyq

param int 8    smplbd   "samples per baud interval."
param int 8    expfft   "expfft: 2^expfft=fft length to use."
param float 0.25    beta   "beta: filter rolloff factor, 0<beta<=.5 "
block sqrtnyq0 sqrtnyq

param arg 1    pole   "lpcf"
block lpf0 lpf

param arg 1    pole   "lpcf"
block lpf1 lpf

param int 40000    npts   "Number of points (preferably a power of 2)"
param int 0    type   "Doppler Spectrum, only Ez supported at this time."
param float 4e+06    fs   "Sampling Rate"
param float 9e+08    fc   "Carrier frequency"
param float 15    v   "Vehicle Velocity, m/s"
param float 0.0002    p   "Power"
param array 3  0  1  3    delays   "Array of multipath delays microsec: number_of_paths t0 t1  ... "
param array 3  0.95  0.63  0.23    powers   "Array of multipath powers: number_of_paths p0 p1  ... "
param int 15    numberArrivals   "Number of Plane Waves arriving plane waves, N where N >=34"
block jkfade0 jkfade

param int 8    smplbd   "samples per baud interval."
param int 8    expfft   "expfft: 2^expfft=fft length to use."
param float 0.25    beta   "beta: filter rolloff factor, 0<beta<=.5 "
block sqrtnyq2 sqrtnyq

param int 8    N   "Ratio input rate/output rate,N"
param array 1  8    phases   "Array: Specifies the phase (delay in samples relative to first input sample) for each output."
block demux1 demux

param int 8    smplbd   "samples per baud interval."
param int 8    expfft   "expfft: 2^expfft=fft length to use."
param float 0.25    beta   "beta: filter rolloff factor, 0<beta<=.5 "
block sqrtnyq3 sqrtnyq

param int 8    N   "Ratio input rate/output rate,N"
param array 1  8    phases   "Array: Specifies the phase (delay in samples relative to first input sample) for each output."
block demux2 demux

param int 5000    npts   "Number of points ( dynamic plot window)"
param int 6    skip   "Number of points to skip"
param file PLOT    title   "Title"
param file X    x_axis   "x Axis"
param file Y    y_axis   "y Axis"
param int 2    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    fixed   "Fixed Bounds ( 0=none, 1=fixed)"
param float -1.2    minx   "Minimum x"
param float 1.2    maxx   "Maximum x"
param float -1.2    miny   "Minimum y"
param float 1.2    maxy   "Maximum y"
param int 0    markerType   "Marker type:0=dot,1=O,2=+,3=X,4=*,5=square,6=diamond,7=triangle"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    bufferType   "Buffer type:0= Float,1= Complex, 2=Integer"
param int 0    mode   "0=Static,1=Dynamic"
block scatter0 scatter

block node2 node

param arg 0    samples_delay   "delay"
block delay0 delay

block node3 node

param arg 0    samples_delay   "delay"
block delay1 delay

param int 8    N   "Filter order"
param float 0.06    mu   "Initial step size"
param float 1.1    muratio   "step size update ratio"
param int 1000    murate   "step size update rate (in samples)"
param float 0.95    varratio   "variance update ratio"
param int 1000    varrate   "variance update rate (in samples)"
param float 1    mean   "mean"
param float 0.6    var   "variance"
param int 0    outputFlag   "Flag: 0=estimate, 1=error"
param float 4    init   "initilization"
block lmsvardc0 blindadapt

block node0 node

block node1 node

param int 100    npts   "Number of points ( dynamic plot window)"
param int 2000    skip   "Number of points to skip"
param file Scatter    title   "Title"
param file X    x_axis   "x Axis"
param file Y    y_axis   "y Axis"
param int 2    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 0    fixed   "Fixed Bounds ( 0=none, 1=fixed)"
param float -1.2    minx   "Minimum x"
param float 1.2    maxx   "Maximum x"
param float -1.2    miny   "Minimum y"
param float 1.2    maxy   "Maximum y"
param int 0    markerType   "Marker type:0=dot,1=O,2=+,3=X,4=*,5=square,6=diamond,7=triangle"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    bufferType   "Buffer type:0= Float,1= Complex, 2=Integer"
param int 1    mode   "0=Static,1=Dynamic"
block scatter1 scatter

param float 1.41421    factor   "Gain factor"
block gain2 gain

param array 2  -1  1    level   "Array of decision levels: # of levels, levels"
block slice0 slice

param int 6    ignore   "Number of samples to ignore for final error tally"
param int 0    err_msg   "Index after which each error is printed to terminal"
block ecount0 ecount

param float 1.41421    factor   "Gain factor"
block gain3 gain

param array 2  -1  1    level   "Array of decision levels: # of levels, levels"
block slice1 slice

param int 6    ignore   "Number of samples to ignore for final error tally"
param int 0    err_msg   "Index after which each error is printed to terminal"
block ecount1 ecount

param int 11    (null)   "Enter number of samples to delay"
param float 0    (null)   "Filter pole <= 1.0"
param int 5000    (null)   "number of points"
param file out0    (null)   "filename"
hblock ercal0 ercal.t

connect bdata0 0 demux0 0  	{bdata0:NULL:NULL,demux0:x:float}
connect demux0 0 linecode0 0  	{demux0:NULL:NULL,linecode0:bindata:float}
connect demux0 1 linecode1 0  	
connect linecode0 0 sqrtnyq0 0  	{linecode0:NULL:NULL,sqrtnyq0:x:float}
connect linecode0 1 node2 0  	
connect linecode1 0 sqrtnyq1 0  	{linecode1:NULL:NULL,sqrtnyq1:x:float}
connect linecode1 1 node3 0  	
connect sqrtnyq1 0 lpf1 0  	{sqrtnyq1:y:float,lpf1:in:float}
connect sqrtnyq0 0 lpf0 0  	{sqrtnyq0:y:float,lpf0:in:float}
connect lpf0 0 jkfade0 0  	{lpf0:out:float,jkfade0:inPhaseIn:float}
connect lpf1 0 jkfade0 1  	{lpf1:out:float,jkfade0:inPhaseIn:float}
connect jkfade0 0 sqrtnyq2 0  	{jkfade0:inPhase:float,sqrtnyq2:x:float}
connect jkfade0 1 sqrtnyq3 0  	
connect sqrtnyq2 0 demux1 0  	{sqrtnyq2:y:float,demux1:x:float}
connect demux1 0 scatter0 0  	
connect sqrtnyq3 0 demux2 0  	{sqrtnyq3:y:float,demux2:x:float}
connect demux2 0 scatter0 1  	
connect scatter0 0 lmsvardc0 0  	
connect scatter0 1 lmsvardc0 1  	
connect node2 0 delay0 0  	{node2:NULL:NULL,delay0:x:float}
connect node2 1 ercal0 0  	
connect delay0 0 ecount0 1  	{delay0:NULL:NULL,ecount0:w:float}
connect node3 0 delay1 0  	{node3:NULL:NULL,delay1:x:float}
connect node3 1 ercal0 2  	
connect delay1 0 ecount1 1  	{delay1:NULL:NULL,ecount1:w:float}
connect lmsvardc0 0 node0 0  	{lmsvardc0:NULL:NULL,node0:x:float}
connect lmsvardc0 1 node1 0  	
connect node0 0 scatter1 0  	
connect node0 1 ercal0 1  	
connect node1 0 scatter1 1  	
connect node1 1 ercal0 3  	
connect scatter1 0 gain2 0  	{scatter1:NULL:NULL,gain2:x:float}
connect scatter1 1 gain3 0  	
connect gain2 0 slice0 0  	{gain2:NULL:NULL,slice0:x:float}
connect slice0 0 ecount0 0  	{slice0:NULL:NULL,ecount0:w:float}
connect gain3 0 slice1 0  	{gain3:NULL:NULL,slice1:x:float}
connect slice1 0 ecount1 0  	{slice1:NULL:NULL,ecount1:w:float}

