
# topology file:  testscatt.t

#--------------------------------------------------- 
# Title: Complex FFT       
# Author: Mr. Demo       
# Date: September 20, 1990       
# Description: Test complex forward/inverse FFT       
#--------------------------------------------------- 

inform title Complex FFT      
inform author Mr. Demo      
inform date September 20, 1990      
inform descrip Test complex forward/inverse FFT      

arg -1 (none)

param file fft.dat    file_name   "File that contains data"
block rdfile0 rdfile

param int 32    npts   "Number of points in each plot (dynamic window size)"
param int 0    skip   "Points to skip before first plot"
param file original    title   "Plot title"
param file X    x_axis   "X Axis label"
param file Y    y_axis   "Y-Axis label"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    mode   "0=Static,1=Dynamic"
param int 1    samplingRate   "Sampling Rate"
block plot0 plot

block cxmakecx0 cxmakecx

param int 32    npts   "Size of FFT"
block cmxfft0 cmxfft

param int 128    npts   "Number of points in each plot (dynamic window size)"
param int 0    skip   "Points to skip before first plot"
param file PLOT    title   "Plot title"
param file X    x_axis   "X-Axis label"
param file Y    y_axis   "Y-Axis label"
param int 1    plotStyleParam   "Plot Style: 1=Color,2=Dashed,1=Same"
param int 0    plotType   "0=Real/Imaginary  1=Mag/Phase Plot"
param int 1    control   "Control: 1=On, 0=Off"
block cxplot0 cxplot

param int 32    npts   "Size of FFT"
block cmxifft0 cmxifft

param int 128    npts   "Number of points ( dynamic plot window)"
param int 0    skip   "Number of points to skip"
param file Scatter    title   "Title"
param file X    x_axis   "x Axis"
param file Y    y_axis   "y Axis"
param int 2    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 0    fixed   "Fixed Bounds ( 0=none, 1=fixed)"
param float -1.2    minx   "Minimum x"
param float 1.2    maxx   "Maximum x"
param float -1.2    miny   "Minimum y"
param float 1.2    maxy   "Maximum y"
param int 0    markerType   "Marker type:0=dot,1=O,2=+,3=X,4=*,5=square,6=diamond,7=triangle"
param int 1    control   "Control: 1=On, 0=Off"
param int 1    bufferType   "Buffer type:0= Float,1= Complex, 2=Integer"
param int 0    mode   "0=Static,1=Dynamic"
block scatter0 scatter

block cxmag0 cxmag

param int 32    npts   "Number of points ( dynamic window size )"
param int 0    skip   "Number of points to skip"
param file spect    title   "Plot title"
param int 0    dbFlag   "Linear = 0, dB = 1"
param int 0    windFlag   "Window:0= Rec.,1=Hamm,2=Hann,3=Blackman"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    timeFlag   "Time Domain On/Off (1/0)"
param float 0    sampFreq   "Sampling Rate (Bin Number if zero,Normalized if Negative"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    bufferType   "Buffer type:0= Float,1= Complex, 2=Integer"
param int 0    mode   "0=Static,1=Dynamic"
param string "Frequency"    xLabelSpectrum   "Spectrum X Axis  Label "
param string "Time"    xLabelTime   "Time X Axis  Label "
block spectrum0 spectrum

block sink0 sink

connect rdfile0 0 plot0 0  	
connect plot0 0 cxmakecx0 0  	
connect cxmakecx0 0 cmxfft0 0  	{cxmakecx0:NULL:NULL,cmxfft0:x:complex}
connect cmxfft0 0 cxplot0 0  	
connect cxplot0 0 cmxifft0 0  	{cxplot0:NULL:NULL,cmxifft0:x:complex}
connect cmxifft0 0 scatter0 0  	
connect scatter0 0 cxmag0 0  	{scatter0:NULL:NULL,cxmag0:x:complex}
connect cxmag0 0 spectrum0 0  	
connect spectrum0 0 sink0 0  	

