# tx.t
# This hblock simulates a data transmitter system.
# Binary data is generated, 2B1Q linecoded, oversampled
# and nyquist filtered.
# creates dsp output file tx.out of signal launched.
# arg 0 - (int) number of bits to generate (2*symbols)
# arg 1 - (int) oversampling rate.
# arg 2 - (int) seed for random data generator
# inputs none.
# output 0 - line conditioned data
# output 1 - coded symbols at symbol rate

arg 0 int 8000 "Number of bits to generate"
arg 1 int 8 "Oversampling rate"
arg 2 int 1 "seed for random data generator"

param arg 0
param arg 2
param int 2048
block bdata0 bdata

param int 2
param arg 1
block coder linecode

param arg 1
param int 8
param float 0.5
block txfilt filtnyq

connect bdata0 0 coder 0
connect coder 0 txfilt 0
connect coder 1 output 1
connect txfilt 0 output 0
