
# topology file:  regpll.t

#--------------------------------------------------- 
# Title: PLL FM Demodulation                
# Author: Sasan Ardalan  
# Date: October 10, 1991                
# Description: Simulate PLL Performance                
#--------------------------------------------------- 

inform title PLL FM Demodulation               
inform author Sasan Ardalan 
inform date October 10, 1991               
inform descrip Simulate PLL Performance               

arg 0 int 5000 "number of samples"

param arg 0    num_of_samples   "number of samples"
param float 0.01    magnitude   "Enter Magnitude"
param float 32000    fs   "Enter Sampling Rate"
param float 100    freq   "Enter Frequency"
param float 0    phase   "Enter Phase"
param float 1    pace_rate   "pace rate to determine how many samples to output"
param int 128    samples_first_time   "number of samples on the first call if paced"
block sine0 sine

param arg 0    npts   "number of samples"
param int 0    skip   "Points to skip before first plot"
param file source    title   "Plot title"
param file X    x_axis   "X Axis label"
param file Y    y_axis   "Y-Axis label"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    mode   "0=Static,1=Dynamic"
param int 1    samplingRate   "Sampling Rate"
block plot0 plot

param float 32000    fs   "Sampling Rate"
param float 1000    fo   "Center Frequency"
param float 1    A   "Amplitude"
block dco1 dco

param arg 0    npts   "number of samples"
param int 0    skip   "Points to skip before first plot"
param file input    title   "Plot title"
param file X    x_axis   "X Axis label"
param file Y    y_axis   "Y-Axis label"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    mode   "0=Static,1=Dynamic"
param int 1    samplingRate   "Sampling Rate"
block plot2 plot

block sink0 sink

block mixer0 mixer

param float 0.99    pole   "Filter pole <= 1.0"
block lpf0 lpf

block node0 node

param float 32000    fs   "Sampling Rate"
param float 1000    fo   "Center Frequency"
param float 1    A   "Amplitude"
block dco0 dco

block sink1 sink

param arg 0    npts   "number of samples"
param int 0    skip   "Number of points to skip"
param file DCO_INPUT    title   "Plot title"
param int 0    dbFlag   "Linear = 0, dB = 1"
param int 0    windFlag   "Window:0= Rec.,1=Hamm,2=Hann,3=Blackman"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    timeFlag   "Time Domain On/Off (1/0)"
param float 0    sampFreq   "Sampling Rate (Bin Number if zero,Normalized if Negative"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    bufferType   "Buffer type:0= Float,1= Complex, 2=Integer"
param int 0    mode   "0=Static,1=Dynamic"
block spectrum1 spectrum

param float 1    factor   "Gain factor"
block gain0 gain

param int 3    desType   "1=Butterworth,2=Chebyshev,3=Elliptic"
param int 1    filterType   "1=LowPass,2=HighPass,3=BandPass,4=BandStop"
param float 32000    fs   "Sampling Frequency, Hz"
param float 0.1    pbdb   "Enter Passband Ripple in dB's"
param float 60    sbdb   "Enter Stopband Attenuation in dB's"
param float 500    fpb   "Passband Freq. Hz/LowPass/HighPass Only"
param float 800    fsb   "Stopband Freq. Hz/LowPass/HighPass Only"
param float 220    fpl   "Lower Passband Freq. Hz/BandPass/BandStop Only"
param float 3400    fpu   "Upper Passband Freq. Hz/BandPass/BandStop Only"
param float 10    fsl   "Lower Stopband Freq. Hz/BandPass/BandStop Only"
param float 4400    fsu   "Upper Stopband Freq. Hz/BandPass/BandStop Only"
param file tmp    filterName   "Filter Name"
block iirfil0 iirfil

param arg 0    npts   "number of samples"
param int 0    skip   "Number of points to skip"
param file Demodulated    title   "Plot title"
param int 0    dbFlag   "Linear = 0, dB = 1"
param int 0    windFlag   "Window:0= Rec.,1=Hamm,2=Hann,3=Blackman"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    timeFlag   "Time Domain On/Off (1/0)"
param float 0    sampFreq   "Sampling Rate (Bin Number if zero,Normalized if Negative"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    bufferType   "Buffer type:0= Float,1= Complex, 2=Integer"
param int 0    mode   "0=Static,1=Dynamic"
block xspectrum0 spectrum

param int 1    samples_delay   "Enter number of samples to delay"
block delay0 delay

connect sine0 0 plot0 0  	
connect plot0 0 dco1 0  	{plot0:NULL:NULL,dco1:lambda:float}
connect dco1 0 plot2 0  	Ĺ"<U
connect dco1 1 sink0 0  	
connect plot2 0 mixer0 0  	FM{plot2:NULL:NULL,mixer0:x:float}
connect mixer0 0 lpf0 0  	{mixer0:z:float,lpf0:in:float}
connect lpf0 0 node0 0  	{lpf0:out:float,node0:x:float}
connect node0 0 dco0 0  	{node0:NULL:NULL,dco0:lambda:float}
connect node0 1 spectrum1 0  	
connect dco0 0 delay0 0  	{dco0:cout:float,delay0:x:float}
connect dco0 1 sink1 0  	
connect spectrum1 0 gain0 0  	{spectrum1:NULL:NULL,gain0:x:float}
connect gain0 0 iirfil0 0  	{gain0:NULL:NULL,iirfil0:x:float}
connect iirfil0 0 xspectrum0 0  	
connect delay0 0 mixer0 1  	{delay0:NULL:NULL,mixer0:x:float}

