
# topology file:  ece652proj.t

#--------------------------------------------------- 
# Title:   Timing Recover Base Band Communication      
# Author:     Sasan Ardalan  
# Date:      November 20, 1990   
# Description:      Timing recovery with prefilter, error counting   
#--------------------------------------------------- 

inform title   Timing Recover Base Band Communication      
inform author     Sasan Ardalan  
inform date      November 20, 1990   
inform descrip      Timing recovery with prefilter, error counting   

arg -1 (none)

param int 100
param int 12
param float 1
param int 128
block data00 bdata

param int 0
param int 8
block linecode00 linecode

param int 8
param int 8
param float .5
block sqrtnyq1 sqrtnyq

param int 8000
param float 1
param int 8
param int 4
param int 0
param float -.5
param float 1
param int 128
block pulse0 pulse

param int 800
param float 0
param int 98765
param float 1
param int 128
block random00 gauss

block add00 add

param int 8
param int 8
param float .5
block sqrtnyq0 sqrtnyq

param int 12
block delay1 delay

block node1 node

param int 800
param int 8
param float 0
param int 0
param int 1
param file eyeDiagram
block eye0 eye

param float 8000
param float 1000
param float .99
block bpf0 bpf

param int 600
param int 0
param file Prefilter
param int 0
param int 0
param int 1
param int 0
param float 0
param int 8
block spectrum1 spectrum

block sqr00 sqr

param int 600
param int 0
param file Squared
param int 0
param int 0
param int 1
param int 0
param float 0
param int 1
block spectrum0 spectrum

param float 8000
param float 1000
param float .99
block bpf00 bpf

param int 500
param int 8
param float 0
param int 100
param int 1
param file timingwave
block eye1 eye

block node0 node

param int 1
param int 1
block jitter0 jitter

param int 1
block zc0 zc

param int 9
block delay0 delay

param int 100
param file trpr.dat
block stats0 stats

param int 800
param int 0
param file Received
param file Samples
param file Amplitude
param int 1
param int 1
block plot1 plot

param int 128
param int 0
param file PLOT
param file X
param file Y
param int 1
param int 0
block plot3 plot

param int 800
param int 0
param file Zero
param file Samples
param file Amplitude
param int 1
param int 1
block plot0 plot

param int 8
block hold0 hold

param array 2  -1  1
block slice0 slice

param int 8
param array 1  4
block demux0 demux

param int 128
param int 0
param file PLOT
param file X
param file Y
param int 1
param int 0
block plot4 plot

param int 30
param int 30000
block ecount0 ecount

connect data00 0 linecode00 0  	
connect linecode00 0 sqrtnyq1 0  	
connect linecode00 1 delay1 0  	
connect sqrtnyq1 0 add00 0  	
connect pulse0 0 jitter0 1  	
connect random00 0 add00 1  	
connect add00 0 sqrtnyq0 0  	
connect sqrtnyq0 0 node1 0  	
connect delay1 0 plot3 0  	
connect node1 0 plot1 0  	
connect node1 1 eye0 0  	
connect eye0 0 bpf0 0  	
connect bpf0 0 spectrum1 0  	
connect spectrum1 0 sqr00 0  	
connect sqr00 0 spectrum0 0  	
connect spectrum0 0 bpf00 0  	
connect bpf00 0 eye1 0  	
connect eye1 0 node0 0  	
connect node0 0 jitter0 0  	
connect node0 1 zc0 0  	
connect jitter0 0 stats0 0  	
connect zc0 0 delay0 0  	
connect delay0 0 plot0 0  	
connect plot1 0 hold0 0  	
connect plot3 0 ecount0 1  	
connect plot0 0 hold0 1  	
connect hold0 0 slice0 0  	
connect slice0 0 demux0 0  	
connect demux0 0 plot4 0  	
connect plot4 0 ecount0 0  	

