
# topology file:  ece652EqProj.t

#--------------------------------------------------- 
# Title: Adaptive Equalization         
# Author: Sasan Ardalan     
# Date: November 26, 1990      
# Description: Basic Baseband Link  
#--------------------------------------------------- 

inform title Adaptive Equalization        
inform author Sasan Ardalan    
inform date November 26, 1990     
inform descrip Basic Baseband Link 

arg -1 (none)

param int 1000    num_of_samples   "total number of samples to output"
param int 12    initialize   "Initialization for shift register"
param float 1    pace_rate   "pace rate to determine how many samples to output"
param int 128    samples_first_time   "number of samples on the first call if paced"
block data00 bdata

param int 0    code_type   "Code type:0-Binary(NRZ),1-Biphase(Manchester),2-2B1Q,3-RZ-AMI(Alternate mark inversion)"
param int 8    smplbd   "Samples per baud"
block linecode00 linecode

param int 8    smplbd   "samples per baud interval."
param int 8    expfft   "expfft: 2^expfft=fft length to use."
param float 0.5    beta   "beta: filter rolloff factor, 0<beta<=.5 "
block sqrtnyq1 sqrtnyq

param int 12    samples_delay   "Enter number of samples to delay"
block delay1 delay

param float 0    pole   "Filter pole <= 1.0"
block lpf0 lpf

block node2 node

param float 1    factor   "Gain factor"
block gain0 gain

param int 0    samples_delay   "Enter number of samples to delay"
block delay2 delay

param float 0    factor   "Gain factor"
block gain1 gain

param int 0    samples_delay   "Enter number of samples to delay"
block delay3 delay

block add0 add

param float 0.2    power   "Noise power"
param int 333    seed   "Seed for random number generator"
block addnoise0 addnoise

param int 8    smplbd   "samples per baud interval."
param int 8    expfft   "expfft: 2^expfft=fft length to use."
param float 0.5    beta   "beta: filter rolloff factor, 0<beta<=.5 "
block sqrtnyq0 sqrtnyq

param int 128    npts   "Number of points in each plot(dynamic window)"
param int 8    smplbd   "Samples per baud"
param float 0    phase   "Baud sampling phase"
param int 0    skip   "Points to skip before first plot"
param file eye    title   "Plot title"
param file Samples    x_axis   "X-Axis label"
param file Y    y_axis   "Y-Axis label"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    mode   "0=Static,1=Dynamic"
block eye0 eye

param int 800    npts   "Number of points in each plot (dynamic window size)"
param int 0    skip   "Points to skip before first plot"
param file PLOT    title   "Plot title"
param file X    x_axis   "X Axis label"
param file Y    y_axis   "Y-Axis label"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    mode   "0=Static,1=Dynamic"
param int 1    samplingRate   "Sampling Rate"
block plot0 plot

param int 8    N   "Ratio input rate/output rate,N"
param array 1  0    phases   "Array: Specifies the phase (delay in samples relative to first input sample) for each output."
block demux0 demux

param array 2  -1  1    level   "Array of decision levels: # of levels, levels"
block slice0 slice

param int 30    ignore   "Number of samples to ignore for final error tally"
param int 30000    err_msg   "Index after which each error is printed to terminal"
block ecount0 ecount

connect data00 0 linecode00 0  	{data00:NULL:NULL,linecode00:bindata:float}
connect linecode00 0 sqrtnyq1 0  	{linecode00:NULL:NULL,sqrtnyq1:x:float}
connect linecode00 1 delay1 0  	{linecode00:NULL:NULL,delay1:x:float}
connect sqrtnyq1 0 lpf0 0  	{sqrtnyq1:y:float,lpf0:in:float}
connect delay1 0 ecount0 0  	{delay1:NULL:NULL,ecount0:w:float}
connect lpf0 0 node2 0  	{lpf0:out:float,node2:x:float}
connect node2 0 gain0 0  	{node2:NULL:NULL,gain0:x:float}
connect node2 1 gain1 0  	{node2:NULL:NULL,gain1:x:float}
connect gain0 0 delay2 0  	{gain0:NULL:NULL,delay2:x:float}
connect delay2 0 add0 0  	
connect gain1 0 delay3 0  	{gain1:NULL:NULL,delay3:x:float}
connect delay3 0 add0 1  	
connect add0 0 addnoise0 0  	{add0:NULL:NULL,addnoise0:inp:float}
connect addnoise0 0 sqrtnyq0 0  	{addnoise0:out:float,sqrtnyq0:x:float}
connect sqrtnyq0 0 eye0 0  	
connect eye0 0 plot0 0  	
connect plot0 0 demux0 0  	{plot0:NULL:NULL,demux0:x:float}
connect demux0 0 slice0 0  	{demux0:NULL:NULL,slice0:x:float}
connect slice0 0 ecount0 1  	{slice0:NULL:NULL,ecount0:x:float}

