
# topology file:  timingRecovery.t

#--------------------------------------------------- 
# Title: п 
# Author: п 
# Date: п 
# Description: п 
#--------------------------------------------------- 

inform title п
inform author п
inform date п
inform descrip п

arg -1 (none)

param int 100    num_of_samples   "total number of samples to output"
param int 12    initialize   "Initialization for shift register"
param float 1    pace_rate   "pace rate to determine how many samples to output"
param int 128    samples_first_time   "number of samples on the first call if paced"
block data00 bdata

param int 0    code_type   "Code type:0-Binary(NRZ),1-Biphase(Manchester),2-2B1Q,3-RZ-AMI(Alternate mark inversion)"
param int 8    smplbd   "Samples per baud"
block linecode00 linecode

param int 8    smplbd   "samples per baud interval."
param int 8    expfft   "expfft: 2^expfft=fft length to use."
param float 0.5    beta   "beta: filter rolloff factor, 0<beta<=.5 "
block filtnyq00 filtnyq

param int 8000    num_of_samples   "total number of samples to output"
param float 1    magnitude   "Magnitude"
param int 8    np   "Period in samples"
param int 4    nw   "Pulse width in samples"
param int 0    nd   "Initial delay in samples"
param float -0.5    dcOffset   "DC offset"
param float 1    pace_rate   "pace rate to determine how many samples to output"
param int 128    samples_first_time   "number of samples on the first call if paced"
block pulse0 pulse

param int 800    num_of_samples   "total number of samples to output"
param float 0    dev   "Noise Standard Deviation"
param int 98765    seed   "Seed for random number generator"
param float 1    pace_rate   "pace rate to determine how many samples to output"
param int 128    samples_first_time   "number of samples on the first call if paced"
block random00 gauss

block add00 add

param int 1    filterType   "Filter Type:1=LowPass,2=HighPass,3=BandPass,4=BandStop"
param int 3    windType   "Window Type:1=Rect,2=Tri,3=Hamm,4=GenHamm,5=Hann,6=Kaiser,7=Cheb,8=Parz"
param int 128    ntap   "Number of Taps"
param float 0.25    fc   "Cut Off Freq. (LowPass/HighPass Only)"
param float 0.25    fl   "Lower cutoff freq. 0<=fl<=0.5"
param float 0.4    fh   "Upper cutoff freq. 0<=fh<=0.5"
param float 0.5    alpha   "Alpha parameter for generalized Hamming window <=1.0"
param float 0.5    dbripple   "Ripple, dB for Chebyshev Window"
param float 0.1    twidth   "Transition Width Chebyshev Window"
param float 30    att   "Attenuation for Kaiser Window"
block firfil0 firfil

param int 14    samples_delay   "Enter number of samples to delay"
block delay1 delay

param int 600    npts   "Number of points in each plot(dynamic window)"
param int 8    smplbd   "Samples per baud"
param float 0    phase   "Baud sampling phase"
param int 0    skip   "Points to skip before first plot"
param file eye    title   "Plot title"
param file Samples    x_axis   "X-Axis label"
param file Y    y_axis   "Y-Axis label"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    mode   "0=Static,1=Dynamic"
block eye0 eye

param float 8000    fs   "Sampling Frequency"
param float 1000    freq   "Center Frequency"
param float 0.99    ro   "Modulus: determines Q. Must be <  1.0"
block bpf0 bpf

param int 600    npts   "Number of points ( dynamic window size )"
param int 0    skip   "Number of points to skip"
param file Prefilter    title   "Plot title"
param int 0    dbFlag   "Linear = 0, dB = 1"
param int 0    windFlag   "Window:0= Rec.,1=Hamm,2=Hann,3=Blackman"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 0    timeFlag   "Time Domain On/Off (1/0)"
param float 0    sampFreq   "Sampling Rate (Bin Number if zero,Normalized if Negative"
param int 8    control   "Control: 1=On, 0=Off"
param int 0    bufferType   "Buffer type:0= Float,1= Complex, 2=Integer"
param int 0    mode   "0=Static,1=Dynamic"
param string "Frequency"    xLabelSpectrum   "Spectrum X Axis  Label "
param string "Time"    xLabelTime   "Time X Axis  Label "
block spectrum1 spectrum

block sqr00 sqr

param int 600    npts   "Number of points ( dynamic window size )"
param int 0    skip   "Number of points to skip"
param file Squared    title   "Plot title"
param int 0    dbFlag   "Linear = 0, dB = 1"
param int 0    windFlag   "Window:0= Rec.,1=Hamm,2=Hann,3=Blackman"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    timeFlag   "Time Domain On/Off (1/0)"
param float 0    sampFreq   "Sampling Rate (Bin Number if zero,Normalized if Negative"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    bufferType   "Buffer type:0= Float,1= Complex, 2=Integer"
param int 0    mode   "0=Static,1=Dynamic"
param string "Frequency"    xLabelSpectrum   "Spectrum X Axis  Label "
param string "Time"    xLabelTime   "Time X Axis  Label "
block spectrum0 spectrum

param float 8000    fs   "Sampling Frequency"
param float 1000    freq   "Center Frequency"
param float 0.99    ro   "Modulus: determines Q. Must be <  1.0"
block bpf00 bpf

param int 128    npts   "Number of points in each plot(dynamic window)"
param int 8    smplbd   "Samples per baud"
param float 0    phase   "Baud sampling phase"
param int 0    skip   "Points to skip before first plot"
param file timing    title   "Plot title"
param file Samples    x_axis   "X-Axis label"
param file Y    y_axis   "Y-Axis label"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    mode   "0=Static,1=Dynamic"
block eye1 eye

block node0 node

param int 1    edge   "Trigger edge: 1= Rising, 0=Falling"
param int 1    sync   "Output Rate. Synchronous/One per cycle"
block jitter0 jitter

param int 1    edge   "Trigger edge: 1= Rising, 0=Falling"
block zc0 zc

param int 6    samples_delay   "Enter number of samples to delay"
block delay0 delay

param int 600    npts   "Number of points in each plot (dynamic window size)"
param int 0    skip   "Points to skip before first plot"
param file PLOT    title   "Plot title"
param file X    x_axis   "X Axis label"
param file Y    y_axis   "Y-Axis label"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    mode   "0=Static,1=Dynamic"
param int 1    samplingRate   "Sampling Rate"
block xplot0 plot

param int 8
block hold0 hold

param array 2  -1  1    level   "Array of decision levels: # of levels, levels"
block slice0 slice

param int 8    N   "Ratio input rate/output rate,N"
param array 1  4    phases   "Array: Specifies the phase (delay in samples relative to first input sample) for each output."
block demux0 demux

param int 30    ignore   "Number of samples to ignore for final error tally"
param int 30000    err_msg   "Index after which each error is printed to terminal"
block ecount0 ecount

param int 100    skip   "Points to skip"
param file trpr.dat    stat_file   "File to store results"
block xstats0 stats

connect data00 0 linecode00 0  	{data00:NULL:NULL,linecode00:bindata:float}
connect linecode00 0 filtnyq00 0  	{linecode00:NULL:NULL,filtnyq00:x:float}
connect linecode00 1 delay1 0  	{linecode00:NULL:NULL,delay1:x:float}
connect filtnyq00 0 add00 0  	
connect pulse0 0 jitter0 1  	{pulse0:NULL:NULL,jitter0:ref:float}
connect random00 0 add00 1  	
connect add00 0 eye0 0  	
connect add00 1 firfil0 0  	{add00:NULL:NULL,firfil0:x:float}
connect firfil0 0 hold0 0  	{firfil0:y:float,hold0:x:float}
connect delay1 0 ecount0 1  	{delay1:NULL:NULL,ecount0:x:float}
connect eye0 0 bpf0 0  	{eye0:NULL:NULL,bpf0:x:float}
connect bpf0 0 spectrum1 0  	
connect spectrum1 0 sqr00 0  	{spectrum1:NULL:NULL,sqr00:x:float}
connect sqr00 0 spectrum0 0  	
connect spectrum0 0 bpf00 0  	{spectrum0:NULL:NULL,bpf00:x:float}
connect bpf00 0 eye1 0  	
connect eye1 0 node0 0  	{eye1:NULL:NULL,node0:x:float}
connect node0 0 jitter0 0  	{node0:NULL:NULL,jitter0:x:float}
connect node0 1 zc0 0  	{node0:NULL:NULL,zc0:x:float}
connect jitter0 0 xstats0 0  	{jitter0:phi:float,xstats0:x:float}
connect zc0 0 delay0 0  	{zc0:y:float,delay0:x:float}
connect delay0 0 xplot0 0  	
connect delay0 1 hold0 1  	{delay0:NULL:NULL,hold0:clock:float}
connect hold0 0 slice0 0  	{hold0:y:float,slice0:x:float}
connect slice0 0 demux0 0  	{slice0:NULL:NULL,demux0:x:float}
connect demux0 0 ecount0 0  	{demux0:NULL:NULL,ecount0:w:float}

