
# topology file:  fsk.t

#--------------------------------------------------- 
# Title: Simple FM Modulation  
# Author: Sasan Ardalan  
# Date: Sasan Ar 
# Description: Sasan Ar 
#--------------------------------------------------- 

inform title Simple FM Modulation 
inform author Sasan Ardalan 
inform date Sasan Ar
inform descrip Sasan Ar

arg 0 int 128 "Samples per Symbol (determines bit rate)"
arg 1 float 32000 "Samples per SymSampling Rate"

param int 128    num_of_samples   "total number of samples to output"
param int 12    initialize   "Initialization for shift register"
param float 1    pace_rate   "pace rate to determine how many samples to output"
param int 128    samples_first_time   "number of samples on the first call if paced"
block bdata0 bdata

param int 0    code_type   "Code type:0-Binary(NRZ),1-Biphase(Manchester),2-2B1Q,3-RZ-AMI(Alternate mark inversion)"
param arg 0    smplbd   "Samples per Symbol (determines bit rate)"
block linecode0 linecode

param arg 0    resetTime   "Samples per Symbol (determines bit rate)"
block unitf0 unitf

param int 128    npts   "Number of points in each plot (dynamic window size)"
param int 0    skip   "Points to skip before first plot"
param file original    title   "Plot title"
param file Samples    x_axis   "X Axis label"
param file Y    y_axis   "Y-Axis label"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    mode   "0=Static,1=Dynamic"
param int 1    samplingRate   "Sampling Rate"
block xplot1 plot

param float 0.1    factor   "Gain factor"
block gain0 gain

param arg 1    fs   "Samples per SymSampling Rate"
param float 1700    fo   "Center Frequency"
param float 1    A   "Amplitude"
block dco0 dco

block sink0 sink

param float 0    power   "Noise power"
param int 333    seed   "Seed for random number generator"
block addnoise0 addnoise

param int 128    npts   "Number of points ( dynamic window size )"
param int 0    skip   "Number of points to skip"
param file Spectrum    title   "Plot title"
param int 0    dbFlag   "Linear = 0, dB = 1"
param int 0    windFlag   "Window:0= Rec.,1=Hamm,2=Hann,3=Blackman"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    timeFlag   "Time Domain On/Off (1/0)"
param float 0    sampFreq   "Sampling Rate (Bin Number if zero,Normalized if Negative"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    bufferType   "Buffer type:0= Float,1= Complex, 2=Integer"
param int 0    mode   "0=Static,1=Dynamic"
block xspectrum0 spectrum

param arg 1    (null)   "Samples per SymSampling Rate"
param int 100    (null)   "Stretch"
hblock fskdemod0 fskdemod.t

param int 128    npts   "Number of points in each plot (dynamic window size)"
param int 0    skip   "Points to skip before first plot"
param file demod    title   "Plot title"
param file Samples    x_axis   "X Axis label"
param file Y    y_axis   "Y-Axis label"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    mode   "0=Static,1=Dynamic"
param int 1    samplingRate   "Sampling Rate"
block xplot0 plot

connect bdata0 0 linecode0 0  	{bdata0:NULL:NULL,linecode0:bindata:float}
connect linecode0 0 unitf0 0  	{linecode0:NULL:NULL,unitf0:in:float}
connect unitf0 0 xplot1 0  	
connect xplot1 0 gain0 0  	{xplot1:NULL:NULL,gain0:x:float}
connect gain0 0 dco0 0  	{gain0:NULL:NULL,dco0:lambda:float}
connect dco0 0 addnoise0 0  	{dco0:cout:float,addnoise0:inp:float}
connect dco0 1 sink0 0  	
connect addnoise0 0 xspectrum0 0  	
connect xspectrum0 0 fskdemod0 0  	
connect fskdemod0 0 xplot0 0  	

