


#
# TCL Script that iterates a number of simulations
# The script stores the results of each run in a list.
# At the end of the iteration loop the results are tabulated.
#
# Author: Sasan Ardalan
# June 25th, 2006
# Modified for Fixed Point FIR  Filter June 17, 2007
#

new
capload fxfirtesttcl

#turn the  probes off

to xspectrum
parambyname control 0



#make the sine0 block the current block
to sine0

set results [list {}]
set freq 5005
to sine0
parambyname freq $freq

for { set i 0}  { $i < 16 } { incr i} {
   set bits [expr $i+4]
   
   puts $bits
   to fxfirtaps0
   parambyname qbits $bits
   parambyname roundoff_bits $bits
   
    run
   puts $mainstats_sigma
   puts $errorstats_sigma
  set sigToError [expr $mainstats_sigma/$errorstats_sigma]
   set sigToErrordB  [expr 20*log10($sigToError)]
   
   lappend results [list $bits $sigToErrordB] 

}

puts -nonewline Bits
puts -nonewline "\t"
puts   S2E

                           

foreach value $results {

   puts  -nonewline [lindex $value 0]
   puts  -nonewline "\t"
   puts   [lindex $value  1]

}

set out [ open fxfir.dat w ]

foreach value $results {
	
   puts  -nonewline $out [lindex $value 0]
   puts  -nonewline $out "\t"
   puts   $out [lindex $value  1]



}
close $out
