
#
# For a sequence of random numbers with normal distribution compute
# E{x xT} where dimension of vector x is order of autocorrelation 10 in this case.
#

#create a 10 by 10 Matrix all zero

mcr A 10 10

#create a vector length=10000 normal distribution variance 1.0 seed 83647

vcr xd 10000 1.0 83647

#create a vector length 10 all zero

vcr x 10

# go through the vector xd extract 10 samples put into x 
# and compute A= A+ x*xT
# as more data is collected A should should approach E{x xT} with scaling factor
# "mopu" stands for Multiply Outer Product  and Update

for {set i 0} { $i <1000 } {incr i 1 } {
  
  vsubv $xd $i 10 $x
  mopu $A $x $x

}

#
# setup scaling matrix
#

mcr mscale 10 10
for {set j 0} { $j< 10 } { incr j 1 } {
    mset $mscale 0.001 $j $j 
}

#scale A and create matrix B

mmpy $A $mscale B

#print Matrix B
#should approach diagonal.

vpr $B 6.2f 


