
# topology file:  carrpulse.t

#--------------------------------------------------- 
# Title:  
# Author:  
# Date:  
# Description:  
#--------------------------------------------------- 

inform title 
inform author 
inform date 
inform descrip 

arg 0 int 12000 "Number of samples"
arg 1 float 64000 "Sampling Rate"

param arg 0    num_of_samples   "Number of samples"
param float 1    magnitude   "Magnitude"
param int 3600    np   "Period in samples"
param int 1200    nw   "Pulse width in samples"
param int 0    nd   "Initial delay in samples"
param float 0    dcOffset   "DC offset"
param float 1    pace_rate   "pace rate to determine how many samples to output"
param int 128    samples_first_time   "number of samples on the first call if paced"
block pulse0 pulse

param arg 0    num_of_samples   "Number of samples"
param float 1    magnitude   "Enter Magnitude"
param arg 1    fs   "Sampling Rate"
param float 1000    freq   "Enter Frequency"
param float 0    phase   "Enter Phase"
param float 1    pace_rate   "pace rate to determine how many samples to output"
param int 128    samples_first_time   "number of samples on the first call if paced"
block sine1 sine

param float 0.995    pole   "Filter pole <= 1.0"
block lpf0 lpf

param arg 0    npts   "Number of samples"
param int 0    skip   "Points to skip before first plot"
param file Baseband    title   "Plot title"
param file Samples    x_axis   "X Axis label"
param file Amplitude    y_axis   "Y-Axis label"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    mode   "0=Static,1=Dynamic"
param int 1    samplingRate   "Sampling Rate"
block plot0 plot

block mixer0 mixer

block node0 node

param float 64000    (null)   "Sampling Rate"
param float 1000    (null)   "Center Frequency"
param float 0.99    (null)   "Modulus for BPF (Determines Q)"
param float 2000    (null)   "Twice carrier frequency"
hblock carrec0 carrec.t

block mixer1 mixer

param int 3    desType   "1=Butterworth,2=Chebyshev,3=Elliptic"
param int 1    filterType   "1=LowPass,2=HighPass,3=BandPass,4=BandStop"
param arg 1    fs   "Sampling Rate"
param float 0.1    pbdb   "Enter Passband Ripple in dB's"
param float 35    sbdb   "Enter Stopband Attenuation in dB's"
param float 500    fpb   "Passband Freq. Hz/LowPass/HighPass Only"
param float 800    fsb   "Stopband Freq. Hz/LowPass/HighPass Only"
param float 220    fpl   "Lower Passband Freq. Hz/BandPass/BandStop Only"
param float 3400    fpu   "Upper Passband Freq. Hz/BandPass/BandStop Only"
param float 10    fsl   "Lower Stopband Freq. Hz/BandPass/BandStop Only"
param float 4400    fsu   "Upper Stopband Freq. Hz/BandPass/BandStop Only"
param file tmp    filterName   "Filter Name"
block iirfil0 iirfil

param arg 0    npts   "Number of samples"
param int 0    skip   "Number of points to skip"
param file PLOT    title   "Plot title"
param int 0    dbFlag   "Linear = 0, dB = 1"
param int 0    windFlag   "Window:0= Rec.,1=Hamm,2=Hann,3=Blackman"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    timeFlag   "Time Domain On/Off (1/0)"
param float 0    sampFreq   "Sampling Rate (Bin Number if zero,Normalized if Negative"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    bufferType   "Buffer type:0= Float,1= Complex, 2=Integer"
param int 0    mode   "0=Static,1=Dynamic"
param string "Frequency"    xLabelSpectrum   "Spectrum X Axis  Label "
param string "Time"    xLabelTime   "Time X Axis  Label "
block spectrum0 spectrum

block sink0 sink

connect pulse0 0 lpf0 0  	{pulse0:NULL:NULL,lpf0:in:float}
connect sine1 0 mixer0 1  	{sine1:NULL:NULL,mixer0:x:float}
connect lpf0 0 plot0 0  	
connect plot0 0 mixer0 0  	{plot0:NULL:NULL,mixer0:x:float}
connect mixer0 0 node0 0  	{mixer0:z:float,node0:x:float}
connect node0 0 carrec0 0  	
connect node0 1 mixer1 1  	{node0:NULL:NULL,mixer1:y:float}
connect carrec0 0 mixer1 0  	{carrec0:NULL:NULL,mixer1:x:float}
connect mixer1 0 iirfil0 0  	{mixer1:z:float,iirfil0:x:float}
connect iirfil0 0 spectrum0 0  	
connect spectrum0 0 sink0 0  	

