
# topology file:  ssb.t

#--------------------------------------------------- 
# Title: Single Side Band Modulation/Demodulation  
# Author: Sasan Ardalan  
# Date:  
# Description:  
#--------------------------------------------------- 

inform title Single Side Band Modulation/Demodulation 
inform author Sasan Ardalan 
inform date 
inform descrip 

arg 0 int 1024 "Number of samples"

param arg 0    num_of_samples   "Number of samples"
param float 1    magnitude   "Enter Magnitude"
param float 32000    fs   "Enter Sampling Rate"
param float 2000    freq   "Enter Frequency"
param float 0    phase   "Enter Phase"
param float 1    pace_rate   "pace rate to determine how many samples to output"
param int 128    samples_first_time   "number of samples on the first call if paced"
block sine1 sine

param arg 0    num_of_samples   "Number of samples"
param float 1    dev   "Noise Standard Deviation"
param int 3759    seed   "Seed for random number generator"
param float 1    pace_rate   "pace rate to determine how many samples to output"
param int 128    samples_first_time   "number of samples on the first call if paced"
block gauss0 gauss

param int 3    desType   "1=Butterworth,2=Chebyshev,3=Elliptic"
param int 1    filterType   "1=LowPass,2=HighPass,3=BandPass,4=BandStop"
param float 32000    fs   "Sampling Frequency, Hz"
param float 0.1    pbdb   "Enter Passband Ripple in dB's"
param float 35    sbdb   "Enter Stopband Attenuation in dB's"
param float 400    fpb   "Passband Freq. Hz/LowPass/HighPass Only"
param float 600    fsb   "Stopband Freq. Hz/LowPass/HighPass Only"
param float 220    fpl   "Lower Passband Freq. Hz/BandPass/BandStop Only"
param float 3400    fpu   "Upper Passband Freq. Hz/BandPass/BandStop Only"
param float 10    fsl   "Lower Stopband Freq. Hz/BandPass/BandStop Only"
param float 4400    fsu   "Upper Stopband Freq. Hz/BandPass/BandStop Only"
param file tmp    filterName   "Filter Name"
block iirfil0 iirfil

param arg 0    num_of_samples   "Number of samples"
param float 1    magnitude   "Enter Magnitude"
param float 32000    fs   "Enter Sampling Rate"
param float 2000    freq   "Enter Frequency"
param float 0    phase   "Enter Phase"
param float 1    pace_rate   "pace rate to determine how many samples to output"
param int 128    samples_first_time   "number of samples on the first call if paced"
block sine0 sine

block node0 node

param int 128    impl   "length of Hilbert transform impulse response"
param float 0.5    fbw   "bandwidth (0 < BW <= 0.5)"
param int 8    fftexp   "log2(fft length)"
block hilbert0 hilbert

param int 64    samples_delay   "Enter number of samples to delay"
block delay0 delay

block mixer1 mixer

param float -1    factor   "Gain factor"
block gain0 gain

block mixer0 mixer

block add0 add

param float 0    power   "Noise power"
param int 333    seed   "Seed for random number generator"
block addnoise0 addnoise

block node1 node

block mixer2 mixer

param int 64    samples_delay   "Enter number of samples to delay"
block delay1 delay

param arg 0    npts   "Number of samples"
param int 0    skip   "Number of points to skip"
param file Modulated    title   "Plot title"
param int 0    dbFlag   "Linear = 0, dB = 1"
param int 0    windFlag   "Window:0= Rec.,1=Hamm,2=Hann,3=Blackman"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    timeFlag   "Time Domain On/Off (1/0)"
param float 32    sampFreq   "Sampling Rate (Bin Number if zero,Normalized if Negative"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    bufferType   "Buffer type:0= Float,1= Complex, 2=Integer"
param int 0    mode   "0=Static,1=Dynamic"
block spectrum3 spectrum

block node2 node

block mixer3 mixer

param int 128    impl   "length of Hilbert transform impulse response"
param float 0.5    fbw   "bandwidth (0 < BW <= 0.5)"
param int 8    fftexp   "log2(fft length)"
block hilbert1 hilbert

param float 1    factor   "Gain factor"
block gain1 gain

block add1 add

param arg 0    npts   "Number of samples"
param int 0    skip   "Number of points to skip"
param file demodbeforefilt    title   "Plot title"
param int 0    dbFlag   "Linear = 0, dB = 1"
param int 0    windFlag   "Window:0= Rec.,1=Hamm,2=Hann,3=Blackman"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    timeFlag   "Time Domain On/Off (1/0)"
param float 32    sampFreq   "Sampling Rate (Bin Number if zero,Normalized if Negative"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    bufferType   "Buffer type:0= Float,1= Complex, 2=Integer"
param int 0    mode   "0=Static,1=Dynamic"
block spectrum2 spectrum

param int 3    desType   "1=Butterworth,2=Chebyshev,3=Elliptic"
param int 1    filterType   "1=LowPass,2=HighPass,3=BandPass,4=BandStop"
param float 32000    fs   "Sampling Frequency, Hz"
param float 0.1    pbdb   "Enter Passband Ripple in dB's"
param float 35    sbdb   "Enter Stopband Attenuation in dB's"
param float 400    fpb   "Passband Freq. Hz/LowPass/HighPass Only"
param float 600    fsb   "Stopband Freq. Hz/LowPass/HighPass Only"
param float 220    fpl   "Lower Passband Freq. Hz/BandPass/BandStop Only"
param float 3400    fpu   "Upper Passband Freq. Hz/BandPass/BandStop Only"
param float 10    fsl   "Lower Stopband Freq. Hz/BandPass/BandStop Only"
param float 4400    fsu   "Upper Stopband Freq. Hz/BandPass/BandStop Only"
param file tmp    filterName   "Filter Name"
block iirfil1 iirfil

param arg 0    npts   "Number of samples"
param int 0    skip   "Number of points to skip"
param file Demodulated    title   "Plot title"
param int 0    dbFlag   "Linear = 0, dB = 1"
param int 0    windFlag   "Window:0= Rec.,1=Hamm,2=Hann,3=Blackman"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    timeFlag   "Time Domain On/Off (1/0)"
param float 32    sampFreq   "Sampling Rate (Bin Number if zero,Normalized if Negative"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    bufferType   "Buffer type:0= Float,1= Complex, 2=Integer"
param int 0    mode   "0=Static,1=Dynamic"
block spectrum1 spectrum

block sink0 sink

param int 150    samples_delay   "Enter number of samples to delay"
block delay2 delay

param arg 0    npts   "Number of samples"
param int 0    skip   "Number of points to skip"
param file Baseband    title   "Plot title"
param int 0    dbFlag   "Linear = 0, dB = 1"
param int 0    windFlag   "Window:0= Rec.,1=Hamm,2=Hann,3=Blackman"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    timeFlag   "Time Domain On/Off (1/0)"
param float 32    sampFreq   "Sampling Rate (Bin Number if zero,Normalized if Negative"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    bufferType   "Buffer type:0= Float,1= Complex, 2=Integer"
param int 0    mode   "0=Static,1=Dynamic"
block spectrum0 spectrum

block sink1 sink

connect sine1 0 mixer0 0  	{sine1:NULL:NULL,mixer0:x:float}
connect sine1 1 mixer1 0  	{sine1:NULL:NULL,mixer1:y:float}
connect gauss0 0 iirfil0 0  	{gauss0:NULL:NULL,iirfil0:x:float}
connect iirfil0 0 node0 0  	{iirfil0:y:float,node0:x:float}
connect sine0 0 mixer2 0  	{sine0:NULL:NULL,mixer2:x:float}
connect sine0 1 mixer3 0  	{sine0:NULL:NULL,mixer3:y:float}
connect node0 0 hilbert0 0  	{node0:NULL:NULL,hilbert0:x:float}
connect node0 1 delay0 0  	
connect node0 2 delay2 0  	
connect hilbert0 0 mixer1 1  	{hilbert0:y:float,mixer1:x:float}
connect delay0 0 mixer0 1  	{delay0:NULL:NULL,mixer0:x:float}
connect mixer1 0 gain0 0  	{mixer1:z:float,gain0:x:float}
connect gain0 0 add0 1  	
connect mixer0 0 add0 0  	
connect add0 0 addnoise0 0  	{add0:NULL:NULL,addnoise0:inp:float}
connect addnoise0 0 node1 0  	{addnoise0:out:float,node1:x:float}
connect node1 0 spectrum3 0  	
connect node1 1 mixer2 1  	{node1:NULL:NULL,mixer2:y:float}
connect mixer2 0 delay1 0  	{mixer2:z:float,delay1:x:float}
connect delay1 0 add1 0  	
connect spectrum3 0 node2 0  	{spectrum3:NULL:NULL,node2:x:float}
connect node2 0 mixer3 1  	{node2:NULL:NULL,mixer3:x:float}
connect mixer3 0 hilbert1 0  	{mixer3:z:float,hilbert1:x:float}
connect hilbert1 0 gain1 0  	{hilbert1:y:float,gain1:x:float}
connect gain1 0 add1 1  	
connect add1 0 spectrum2 0  	
connect spectrum2 0 iirfil1 0  	{spectrum2:NULL:NULL,iirfil1:x:float}
connect iirfil1 0 spectrum1 0  	
connect spectrum1 0 sink0 0  	
connect delay2 0 spectrum0 0  	
connect spectrum0 0 sink1 0  	

