
# topology file:  hlibert_impulse.t

#--------------------------------------------------- 
# Title: Hilbert Transform Impulse Response 
# Author: Sasan Ardalan 
# Date: May 1992 
# Description: Hilbert Transform Impulse Response 
#--------------------------------------------------- 

inform title Hilbert Transform Impulse Response
inform author Sasan Ardalan
inform date May 1992
inform descrip Hilbert Transform Impulse Response

arg -1 (none)

param int 4096    length   "Enter number of samples"
block impulse0 impulse

param int 64    impl   "length of Hilbert transform impulse response"
param float 0.5    fbw   "bandwidth (0 < BW <= 0.5)"
param int 8    fftexp   "log2(fft length)"
block hilbert0 hilbert

param int 128    npts   "Number of points ( dynamic window size )"
param int 0    skip   "Number of points to skip"
param file Spectrum    title   "Plot title"
param int 0    dbFlag   "Linear = 0, dB = 1"
param int 0    windFlag   "Window:0= Rec.,1=Hamm,2=Hann,3=Blackman"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    timeFlag   "Time Domain On/Off (1/0)"
param float 0    sampFreq   "Sampling Rate (Bin Number if zero,Normalized if Negative"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    bufferType   "Buffer type:0= Float,1= Complex, 2=Integer"
param int 0    mode   "0=Static,1=Dynamic"
block prbspectrum0968 spectrum

connect impulse0 0 hilbert0 0  	{impulse0:NULL:NULL,hilbert0:x:float}
connect hilbert0 0 prbspectrum0968 0  	

