


#
# TCL Script that iterates a number of simulations
# The script stores the results of each run in a list.
# At the end of the iteration loop the results are tabulated.
#
# Author: Sasan Ardalan
# June 25th, 2006
# Modified for PA June 25, 2007
#

new
capload testpa.t

#turn the  probes off

to prbspectrum066
parambyname control 0


to patx0
parambyname out1dB 20.0
parambyname G 30.0
parambyname sourceR 50.0
parambyname bo 0.0
parambyname windowLength 50

set results [list {}]
set freq 1500
to sine0
parambyname freq $freq

set deltaA 0.005

for { set i 0}  { $i < 100 } { incr i} {
   set amplitude [expr $i*$deltaA+$deltaA]
   
   puts $amplitude
   to sine0
   parambyname magnitude $amplitude
   
   
    
   run
    
   puts $pastats_sigma
   
   set outdBm  [expr 10*log10($pastats_sigma*$pastats_sigma/50.0)]
   set indBm  [expr 10*log10($amplitude*$amplitude*.5/50.0)]
   lappend results [list $indBm $outdBm] 

}

puts -nonewline Input(dBm)
puts -nonewline "\t"
puts   Output(dBm)

                           

foreach value $results {

   puts  -nonewline [lindex $value 0]
   puts  -nonewline "\t"
   puts   [lindex $value  1]

}

set out [ open paresults.dat w ]

foreach value $results {
	
   puts  -nonewline $out [lindex $value 0]
   puts  -nonewline $out "\t"
   puts   $out [lindex $value  1]



}
close $out
