
# topology file:  test_hilbert.t

#--------------------------------------------------- 
# Title: Test Hlibert Transform  
# Author: Sasan Ardalan 
# Date: May 1992 
# Description: Check to see if sine waves 90 degrees out of  phase. 
#--------------------------------------------------- 

inform title Test Hlibert Transform 
inform author Sasan Ardalan
inform date May 1992
inform descrip Check to see if sine waves 90 degrees out of  phase.

arg -1 (none)

param int 4096    num_of_samples   "total number of samples to output"
param float 1    magnitude   "Enter Magnitude"
param float 32000    fs   "Enter Sampling Rate"
param float 1000    freq   "Enter Frequency"
param float 0    phase   "Enter Phase"
param float 1    pace_rate   "pace rate to determine how many samples to output"
param int 128    samples_first_time   "number of samples on the first call if paced"
block sine0 sine

block node0 node

param int 64    impl   "length of Hilbert transform impulse response"
param float 0.5    fbw   "bandwidth (0 < BW <= 0.5)"
param int 8    fftexp   "log2(fft length)"
block hilbert0 hilbert

param int 32    samples_delay   "Enter number of samples to delay"
block delay0 delay

param int 128    npts   "Number of points ( dynamic plot window)"
param int 0    skip   "Number of points to skip"
param file Scatter    title   "Title"
param file X    x_axis   "x Axis"
param file Y    y_axis   "y Axis"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    fixed   "Fixed Bounds ( 0=none, 1=fixed)"
param float -1.2    minx   "Minimum x"
param float 1.2    maxx   "Maximum x"
param float -1.2    miny   "Minimum y"
param float 1.2    maxy   "Maximum y"
param int 0    markerType   "Marker type:0=dot,1=O,2=+,3=X,4=*,5=square,6=diamond,7=triangle"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    bufferType   "Buffer type:0= Float,1= Complex, 2=Integer"
param int 0    mode   "0=Static,1=Dynamic"
block scatter0 scatter

connect sine0 0 node0 0  	{sine0:NULL:NULL,node0:x:float}
connect node0 0 hilbert0 0  	{node0:NULL:NULL,hilbert0:x:float}
connect node0 1 delay0 0  	{node0:NULL:NULL,delay0:x:float}
connect hilbert0 0 scatter0 1  	
connect delay0 0 scatter0 0  	

