
# topology file:  twt.t

#--------------------------------------------------- 
# Title: TWT using Saleh Model 
# Author: Sasan H. Ardalan  
# Date: June 25, 2007  
# Description: Implements TWT using Saleh model based on Fig.4 in IEEE Trans. Comm. , Nov. 1981, pages 1715-1720 
#--------------------------------------------------- 

inform title TWT using Saleh Model
inform author Sasan H. Ardalan 
inform date June 25, 2007 
inform descrip Implements TWT using Saleh model based on Fig.4 in IEEE Trans. Comm. , Nov. 1981, pages 1715-1720

arg 0 int 4096 "Number of Samples"

param arg 0    num_of_samples   "Number of Samples"
param float 1    magnitude   "Enter Magnitude"
param float 32000    fs   "Enter Sampling Rate"
param float 5000    freq   "Enter Frequency"
param float 0    phase   "Enter Phase"
param float 1    pace_rate   "pace rate to determine how many samples to output"
param int 128    samples_first_time   "number of samples on the first call if paced"
block sine0 sine

param arg 0    num_of_samples   "Number of Samples"
param float 6    magnitude   "Enter Magnitude"
param float 32000    fs   "Enter Sampling Rate"
param float 100    freq   "Enter Frequency"
param float 0    phase   "Enter Phase"
param float 1    pace_rate   "pace rate to determine how many samples to output"
param int 128    samples_first_time   "number of samples on the first call if paced"
block sine1 sine

param float 1.6623    alphaA   " alphaA "
param float 0.0552    betaA   " betaA "
param float 0.1533    alphaPhi   " alphaPhi "
param float 0.3456    betaPhi   " betaPhi "
block nonlinsaleh0 nonlinsaleh

param int 0    skip   "Points to skip"
param file stat.dat    stat_file   "File to store results"
block nlstat stats

param int 128    npts   "Number of points ( dynamic window size )"
param int 0    skip   "Number of points to skip"
param file Spectrum    title   "Plot title"
param int 0    dbFlag   "Linear = 0, dB = 1"
param int 0    windFlag   "Window:0= Rec.,1=Hamm,2=Hann,3=Blackman"
param int 1    plotStyleParam   "Plot Style: 1=Line,2=Points,5=Bar Chart"
param int 1    timeFlag   "Time Domain On/Off (1/0)"
param float 0    sampFreq   "Sampling Rate (Bin Number if zero,Normalized if Negative"
param int 1    control   "Control: 1=On, 0=Off"
param int 0    bufferType   "Buffer type:0= Float,1= Complex, 2=Integer"
param int 0    mode   "0=Static,1=Dynamic"
block nlspectrum spectrum

connect sine0 0 nonlinsaleh0 1  	{sine0:NULL:NULL,nonlinsaleh0: scos : float }
connect sine0 1 nonlinsaleh0 2  	{sine0:NULL:NULL,nonlinsaleh0: ssin : float }
connect sine1 0 nonlinsaleh0 0  	{sine1:NULL:NULL,nonlinsaleh0: r : float }
connect nonlinsaleh0 0 nlstat 0  	{nonlinsaleh0: y : float ,nlstat:x:float}
connect nlstat 0 nlspectrum 0  	

