 
#ifdef LICENSE

/*  Capsim (r) Text Mode Kernel (TMK) Star Library (Blocks)
    Copyright (C) 1989-2002  XCAD Corporation 

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    http://www.xcad.com
    XCAD Corporation
    Raleigh, North Carolina */

#endif
 
#ifdef SHORT_DESCRIPTION

This star is a self-contained second order delta sigma modulator.

#endif
 
#ifdef PROGRAMMERS

#endif






#include <stdio.h>
#include <math.h>

/* Note: these paths are installation dependent! */
#include <capsim.h>
#include <stars.h>



 

#include <math.h>



/*
 *           STATES STRUCTURE 
 */ 
typedef struct {
      float  __y;
      float  __x;
      float  __p;
      float  __xold;
      float  __yold;
      int  __numberOutputBuffers;
     } state_t,*state_Pt;

/*
 *         STATE DEFINES 
 */ 
#define y (state_P->__y)
#define x (state_P->__x)
#define p (state_P->__p)
#define xold (state_P->__xold)
#define yold (state_P->__yold)
#define numberOutputBuffers (state_P->__numberOutputBuffers)

/*         
 *    INPUT BUFFER DEFINES 
 */ 
#define in(DELAY) (*((float  *)PIN(0,DELAY)))

/*         
 *    PARAMETER DEFINES 
 */ 
#define g1 (param_P[0]->value.f)
#define g2 (param_P[1]->value.f)
#define delta (param_P[2]->value.f)
/*-------------- BLOCK CODE ---------------*/


ds2 

(run_state,block_P)

	int run_state;
	block_Pt block_P;
{
	param_Pt *param_P = block_P->param_AP;
	star_Pt star_P = block_P->star_P;

     
	state_Pt state_P = (state_Pt)star_P->state_P;
     
/*
 *              Declarations 
 */
 

	int i;


switch (run_state) {

 
 


 
case PARAM_INIT: 
    {
      int indexModel88 = block_P->model_index;
     char   *pdef0 = "The gain of the first integrator";
     char   *ptype0 = "float";
     char   *pval0 = "1.0";
     char   *pname0 = "g1";
     char   *pdef1 = "The gain of the second integrator";
     char   *ptype1 = "float";
     char   *pval1 = "1.0";
     char   *pname1 = "g2";
     char   *pdef2 = "Binary Quantizer Level";
     char   *ptype2 = "float";
     char   *pval2 = "1.0";
     char   *pname2 = "delta";
KrnModelParam(indexModel88,0 ,pdef0,ptype0,pval0,pname0);
KrnModelParam(indexModel88,1 ,pdef1,ptype1,pval1,pname1);
KrnModelParam(indexModel88,2 ,pdef2,ptype2,pval2,pname2);

      }
break;
   


/*         
 *    INPUT BUFFER SYSTEM  INITS 
 */ 
 case INPUT_BUFFER_INIT:
 {
 int indexIC = block_P->model_index;
     char   *ptypeIn0 = "float";
     char   *pnameIn0 = "in";
KrnModelConnectionInput(indexIC,0 ,pnameIn0,ptypeIn0);
}
 break;

/*
 *        SYSTEM INITIALIZATION CODE 
 */
case SYSTEM_INIT:
     
	star_P->state_P = (char*)calloc(1,sizeof(state_t));
	state_P = (state_Pt)star_P->state_P;
            y=1.0;
       x=0.0;
       p=0.0;
       xold=0.0;
       yold=0.0;


         
   if(NO_INPUT_BUFFERS() != 1 ){
       fprintf(stdout,"%s:1 inputs expected; %d connected\n",
              STAR_NAME,NO_INPUT_BUFFERS());
	      return(200);
   }

   SET_CELL_SIZE_IN(0,sizeof(float));

break;

/*
 *               USER INITIALIZATION CODE 
 */
case USER_INIT: 

 

       /* note and store the number of output buffers */
        if((numberOutputBuffers = NO_OUTPUT_BUFFERS() ) <= 0) {
                fprintf(stderr,"ds2: no output buffers\n");
                return(1); /* no output buffers */
        }
        if(numberOutputBuffers > 2) {
                fprintf(stderr,"ds2: more than two outputs\n");
                return(2);
        }


break;

/* 
 *             MAIN CODE 
 */
case MAIN_CODE: 

 

while(IT_IN(0))
{

	x = xold + g1*in(0) - g1*p;

	y = yold + g2*xold - g2*p;

	p = delta;
	if(y < 0.0) p = -delta;

	
	if(numberOutputBuffers==1) {
		if(IT_OUT(0)) {
			KrnOverflow("ds2",0);
			return(99);
		}
		OUTF(0,0)=p;
	} else {
		if(IT_OUT(0)) {
			KrnOverflow("ds2",0);
			return(99);
		}
		OUTF(0,0)=p;
		if(IT_OUT(1)) {
			KrnOverflow("ds2",1);
			return(99);
		}
		OUTF(0,0)=y;

	}


	xold = x;
	yold = y;
	
}


break;

/*             
 *            WRAPUP CODE 
 */
case WRAPUP: 

 



break;
}
return(0);
}
