 
#ifdef LICENSE

/*  Capsim (r) Text Mode Kernel (TMK) Star Library (Blocks)
    Copyright (C) 1989-2002  XCAD Corporation 

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    http://www.xcad.com
    XCAD Corporation
    Raleigh, North Carolina */

#endif
 
#ifdef SHORT_DESCRIPTION

Block implements fixed point cascade form IIR digital filter.

#endif
 
#ifdef PROGRAMMERS

#endif






#include <stdio.h>
#include <math.h>

/* Note: these paths are installation dependent! */
#include <capsim.h>
#include <stars.h>



#define MAX_SECTIONS  35

/*
 *           STATES STRUCTURE 
 */ 
typedef struct {
      int  __ycas_A[MAX_SECTIONS];
      int  __xs_A[3];
      int  __ys_A[3];
      int  __factorOne1;
      int  __factorOne0;
      int  __factorOneLess;
      int  __poleSec1FxFact0_A[MAX_SECTIONS];
      int  __poleSec1FxFact1_A[MAX_SECTIONS];
      int  __poleSec1LessFlag_A[MAX_SECTIONS];
      int  __poleSec2FxFact0_A[MAX_SECTIONS];
      int  __poleSec2FxFact1_A[MAX_SECTIONS];
      int  __poleSec2LessFlag_A[MAX_SECTIONS];
      int  __zeroSec1FxFact0_A[MAX_SECTIONS];
      int  __zeroSec1FxFact1_A[MAX_SECTIONS];
      int  __zeroSec1LessFlag_A[MAX_SECTIONS];
      int  __zeroSec2FxFact0_A[MAX_SECTIONS];
      int  __zeroSec2FxFact1_A[MAX_SECTIONS];
      int  __zeroSec2LessFlag_A[MAX_SECTIONS];
      double  __fs;
      double  __wnorminv;
      int  __ns;
      int  __n;
      int  __maxv;
     } state_t,*state_Pt;

/*
 *         STATE DEFINES 
 */ 
#define ycas_A (state_P->__ycas_A)
#define xs_A (state_P->__xs_A)
#define ys_A (state_P->__ys_A)
#define factorOne1 (state_P->__factorOne1)
#define factorOne0 (state_P->__factorOne0)
#define factorOneLess (state_P->__factorOneLess)
#define poleSec1FxFact0_A (state_P->__poleSec1FxFact0_A)
#define poleSec1FxFact1_A (state_P->__poleSec1FxFact1_A)
#define poleSec1LessFlag_A (state_P->__poleSec1LessFlag_A)
#define poleSec2FxFact0_A (state_P->__poleSec2FxFact0_A)
#define poleSec2FxFact1_A (state_P->__poleSec2FxFact1_A)
#define poleSec2LessFlag_A (state_P->__poleSec2LessFlag_A)
#define zeroSec1FxFact0_A (state_P->__zeroSec1FxFact0_A)
#define zeroSec1FxFact1_A (state_P->__zeroSec1FxFact1_A)
#define zeroSec1LessFlag_A (state_P->__zeroSec1LessFlag_A)
#define zeroSec2FxFact0_A (state_P->__zeroSec2FxFact0_A)
#define zeroSec2FxFact1_A (state_P->__zeroSec2FxFact1_A)
#define zeroSec2LessFlag_A (state_P->__zeroSec2LessFlag_A)
#define fs (state_P->__fs)
#define wnorminv (state_P->__wnorminv)
#define ns (state_P->__ns)
#define n (state_P->__n)
#define maxv (state_P->__maxv)

/*         
 *    INPUT BUFFER DEFINES 
 */ 
#define x(DELAY) (*((int  *)PIN(0,DELAY)))

/*         
 *    OUTPUT BUFFER  DEFINES 
 */ 
#define y(delay) *(int  *)POUT(0,delay)

/*         
 *    PARAMETER DEFINES 
 */ 
#define filename (param_P[0]->value.s)
#define qbits (param_P[1]->value.d)
#define size (param_P[2]->value.d)
#define roundoff_bits (param_P[3]->value.d)
#define accumSizeRound (param_P[4]->value.d)
#define saturation_mode (param_P[5]->value.d)
/*-------------- BLOCK CODE ---------------*/


fxcasfil 

(run_state,block_P)

	int run_state;
	block_Pt block_P;
{
	param_Pt *param_P = block_P->param_AP;
	star_Pt star_P = block_P->star_P;

     
	state_Pt state_P = (state_Pt)star_P->state_P;
     
/*
 *              Declarations 
 */
 

   	int i,j,jj,jt;
	float wnorm;
        FILE *ird_F;
	int  val;
	float  factor;
	int    fxfactor;
	int xs01,xs00,xs0less;
	int xs11,xs10,xs1less;
	int xs21,xs20,xs2less;
	int ys11,ys10,ys1less;
	int ys21,ys20,ys2less;
		
        int sum0,sum1;
	int out0,out1;

        double poleSec1_A[MAX_SECTIONS];
        double poleSec2_A[MAX_SECTIONS];
        double zeroSec1_A[MAX_SECTIONS];
	double zeroSec2_A[MAX_SECTIONS];
	


switch (run_state) {

 
 


 
case PARAM_INIT: 
    {
      int indexModel88 = block_P->model_index;
     char   *pdef0 = "File with cascade filter parameters";
     char   *ptype0 = "file";
     char   *pval0 = "tmp.cas";
     char   *pname0 = "filename";
     char   *pdef1 = "Number of bits to represent fraction";
     char   *ptype1 = "int";
     char   *pval1 = "8";
     char   *pname1 = "qbits";
     char   *pdef2 = "Word length";
     char   *ptype2 = "int";
     char   *pval2 = "32";
     char   *pname2 = "size";
     char   *pdef3 = "Accumulator Roundoff bits";
     char   *ptype3 = "int";
     char   *pval3 = "8";
     char   *pname3 = "roundoff_bits";
     char   *pdef4 = "Accumulator Word length";
     char   *ptype4 = "int";
     char   *pval4 = "32";
     char   *pname4 = "accumSizeRound";
     char   *pdef5 = "saturation mode";
     char   *ptype5 = "int";
     char   *pval5 = "1";
     char   *pname5 = "saturation_mode";
KrnModelParam(indexModel88,0 ,pdef0,ptype0,pval0,pname0);
KrnModelParam(indexModel88,1 ,pdef1,ptype1,pval1,pname1);
KrnModelParam(indexModel88,2 ,pdef2,ptype2,pval2,pname2);
KrnModelParam(indexModel88,3 ,pdef3,ptype3,pval3,pname3);
KrnModelParam(indexModel88,4 ,pdef4,ptype4,pval4,pname4);
KrnModelParam(indexModel88,5 ,pdef5,ptype5,pval5,pname5);

      }
break;
   


/*         
 *    OUTPUT BUFFER SYSTEM  INITS 
 */ 
 case OUTPUT_BUFFER_INIT: 
 {
 int indexOC = block_P->model_index;
     char   *ptypeOut0 = "int";
     char   *pnameOut0 = "y";
KrnModelConnectionOutput(indexOC,0 ,pnameOut0,ptypeOut0);
}
 break;

/*         
 *    INPUT BUFFER SYSTEM  INITS 
 */ 
 case INPUT_BUFFER_INIT:
 {
 int indexIC = block_P->model_index;
     char   *ptypeIn0 = "int";
     char   *pnameIn0 = "x";
KrnModelConnectionInput(indexIC,0 ,pnameIn0,ptypeIn0);
}
 break;

/*
 *        SYSTEM INITIALIZATION CODE 
 */
case SYSTEM_INIT:
     
	star_P->state_P = (char*)calloc(1,sizeof(state_t));
	state_P = (state_Pt)star_P->state_P;
     


         
   if(NO_OUTPUT_BUFFERS() != 1 ){
       fprintf(stdout,"%s:1 outputs expected; %d connected\n",
              STAR_NAME,NO_OUTPUT_BUFFERS());
	      return(201);
   }

   SET_CELL_SIZE_OUT(0,sizeof(int));

         
   if(NO_INPUT_BUFFERS() != 1 ){
       fprintf(stdout,"%s:1 inputs expected; %d connected\n",
              STAR_NAME,NO_INPUT_BUFFERS());
	      return(200);
   }

   SET_CELL_SIZE_IN(0,sizeof(int));

break;

/*
 *               USER INITIALIZATION CODE 
 */
case USER_INIT: 

 

	/*
	 * open file containing filter coefficients. Check 
	 * to see if it exists.
	 *
	 */
        if( (ird_F = fopen(filename,"r")) == NULL) {
		fprintf(stderr,"Casfil: File could not be opened  \n");
		return(4);
	}
	/*
	 * Read in the filter coefficients and filter parameters.
	 *
	 */
         fscanf(ird_F,"%d",&ns);
         if( ns > MAX_SECTIONS) {
		fprintf(stderr,"Casfil: Too many sections  \n");
		return(5);
	}	 
	 
      	 for (i=0; i<ns; i++) 
             {
              fscanf(ird_F,"%lf %lf",&zeroSec1_A[i],&zeroSec2_A[i]); 
	     }
      	 for (i=0; i<ns; i++) 
             {
              fscanf(ird_F,"%lf %lf",&poleSec1_A[i],&poleSec2_A[i]); 
	     }
         fscanf(ird_F,"%f",&fs);  
         fscanf(ird_F,"%f",&wnorm); 
	 wnorminv=1.0/wnorm;
	 for (i=0; i<3; i++)
         {
              xs_A[i] = 0;
              ys_A[i] = 0;
         }
         for (i=0; i<MAX_SECTIONS; i++){ ycas_A[i]=0.0;}   
              n = 0;
	/* 
	 * Calculate the maximum number to be represented by size bits 
	 */
        maxv=1;
        maxv <<= (size-1); 
	maxv -= 1;
	val=1; 
	val <<= qbits;	

        factor=1.0;	
        if (factor>0.0)
		   fxfactor = (int)(factor * val + 0.5);
              else
		   fxfactor = (int)(factor * val - 0.5);
         if (fxfactor > maxv || (-fxfactor) > maxv) {
        	    fprintf(stderr,"fxcasfil: gain can not be represented by size bits\n");
        	    return(1);
         }	 
	 Fx_Part(size,fxfactor,&factorOne1,&factorOne0,&factorOneLess);
	      
     	 for (i=0; i<ns; i++) {

              factor=zeroSec1_A[i];	
              if (factor>0.0)
		   fxfactor = (int)(factor * val + 0.5);
              else
		   fxfactor = (int)(factor * val - 0.5);
              if (fxfactor > maxv || (-fxfactor) > maxv) {
        	    fprintf(stderr,"fxcasfil: gain can not be represented by size bits\n");
        	    return(2);
              }	 
	      Fx_Part(size,fxfactor,&zeroSec1FxFact1_A[i],&zeroSec1FxFact0_A[i],&zeroSec1LessFlag_A[i]);
          

              factor=zeroSec2_A[i];	
              if (factor>0.0)
		   fxfactor = (int)(factor * val + 0.5);
              else
		   fxfactor = (int)(factor * val - 0.5);
              if (fxfactor > maxv || (-fxfactor) > maxv) {
        	    fprintf(stderr,"fxcasfil: gain can not be represented by size bits\n");
        	    return(3);
              }	 
	      Fx_Part(size,fxfactor,&zeroSec2FxFact1_A[i],&zeroSec2FxFact0_A[i],&zeroSec2LessFlag_A[i]);

	      
	      /* use negative so we can just accumulate */
              factor= -poleSec1_A[i];	
              if (factor>0.0)
		   fxfactor = (int)(factor * val + 0.5);
              else
		   fxfactor = (int)(factor * val - 0.5);
              if (fxfactor > maxv || (-fxfactor) > maxv) {
        	    fprintf(stderr,"fxcasfil: gain can not be represented by size bits\n");
        	    return(4);
              }	 
	      Fx_Part(size,fxfactor,&poleSec1FxFact1_A[i],&poleSec1FxFact0_A[i],&poleSec1LessFlag_A[i]);
	      
	      /* use negative so we can just accumulate */
              factor= -poleSec2_A[i];	
              if (factor>0.0)
		   fxfactor = (int)(factor * val + 0.5);
              else
		   fxfactor = (int)(factor * val - 0.5);
              if (fxfactor > maxv || (-fxfactor) > maxv) {
        	    fprintf(stderr,"fxcasfil: gain can not be represented by size bits\n");
        	    return(5);
              }	 
	      Fx_Part(size,fxfactor,&poleSec2FxFact1_A[i],&poleSec2FxFact0_A[i],&poleSec2LessFlag_A[i]);
	      
	}      
	      

break;

/* 
 *             MAIN CODE 
 */
case MAIN_CODE: 

 


        while (IT_IN(0))
        {
           for (j=0; j< ns; j++){
                    if (j==0){
                              xs_A[1]=0;
                              xs_A[2]=0;
                              xs_A[0]=x(0);
                              if (n>0) xs_A[1]=x(1);
                              if (n>1) xs_A[2]=x(2);
                    }
                    if (j>0) { 
                             for (jj=0; jj<3; jj++)
                                           xs_A[jj] = ys_A[jj];
                    }

                    jt = j*3;
                    for (jj=0; jj<2; jj++)  
                        ys_A[jj+1] = ycas_A[jt+jj];

		     
		     
	       /* 
	        * Implementing:
                * ys_A[0]=xs_A[0]+(zeroSec1_A[j]*xs_A[1])+(zeroSec2_A[j]*xs_A[2])-(poleSec1_A[j]*ys_A[1])-(poleSec2_A[j]*ys_A[2]);
                */
		Fx_Part(size,xs_A[0],&xs01,&xs00,&xs0less);
		Fx_Part(size,xs_A[1],&xs11,&xs10,&xs1less);
		Fx_Part(size,xs_A[2],&xs21,&xs20,&xs2less);
		Fx_Part(size,ys_A[1],&ys11,&ys10,&ys1less);
		Fx_Part(size,ys_A[2],&ys21,&ys20,&ys2less);
		
		Fx_MultVar(xs0less,factorOneLess,size,xs01,xs00,
                                    factorOne1,factorOne0,&sum1,&sum0);
		

		Fx_MultVar(zeroSec1LessFlag_A[j],xs1less,size,zeroSec1FxFact1_A[j],zeroSec1FxFact0_A[j],
                                    xs11,xs10,&out1,&out0);

                Fx_AddVar(size,saturation_mode,sum1,sum0,out1,out0,&sum1,&sum0); 

		Fx_MultVar(zeroSec2LessFlag_A[j],xs2less,size,zeroSec2FxFact1_A[j],zeroSec2FxFact0_A[j],
                                    xs21,xs20,&out1,&out0);

                Fx_AddVar(size,saturation_mode,out1,out0,sum1,sum0,&sum1,&sum0); 

		Fx_MultVar(poleSec1LessFlag_A[j],ys1less,size,poleSec1FxFact1_A[j],poleSec1FxFact0_A[j],
                                    ys11,ys10,&out1,&out0);
				    
                Fx_AddVar(size,saturation_mode,out1,out0,sum1,sum0,&sum1,&sum0); 

		Fx_MultVar(poleSec2LessFlag_A[j],ys2less,size,poleSec2FxFact1_A[j],poleSec2FxFact0_A[j],
                                    ys21,ys20,&out1,&out0);
		
                Fx_AddVar(size,saturation_mode,out1,out0,sum1,sum0,&sum1,&sum0); 
		

		Fx_RoundVar(size,accumSizeRound,roundoff_bits,sum1,sum0,&ys_A[0]);

		
                for (jj=0; jj<2; jj++)   
                    ycas_A[jt+jj] = ys_A[jj];
          }

          if(IT_OUT(0)) {
			KrnOverflow("casfil",0);
			return(99);
	  }
          //y(0) = ys_A[0]*wnorminv;
	  y(0) = ys_A[0];
          n = n+1;
        
    }
    return(0);


break;

/*             
 *            WRAPUP CODE 
 */
case WRAPUP: 

 



break;
}
return(0);
}
