 
#ifdef LICENSE

/*
 * (c) 2007 XCAD Corporation, Portland, Oregon, All Rights Reserved.
 * Acknowledgement Dr. Yoon
 */



#endif
 
#ifdef SHORT_DESCRIPTION

Model IQ imbalance specifying amplitude mismatch (percent) and phase (degrees).

#endif
 
#ifdef PROGRAMMERS

#endif






#include <stdio.h>
#include <math.h>

/* Note: these paths are installation dependent! */
#include <capsim.h>
#include <stars.h>



 



 

#define PI 3.1415926535898


/*
 *           STATES STRUCTURE 
 */ 
typedef struct {
       float   __IA;
       float   __QA;
       float   __iampe;
       float   __qampe;
       complex   __ipe;
       complex   __qpe;
     } state_t,*state_Pt;

/*
 *         STATE DEFINES 
 */ 
#define  IA  (state_P->__IA)
#define  QA  (state_P->__QA)
#define  iampe  (state_P->__iampe)
#define  qampe  (state_P->__qampe)
#define  ipe  (state_P->__ipe)
#define  qpe  (state_P->__qpe)

/*         
 *    INPUT BUFFER DEFINES 
 */ 
#define inStream(DELAY) (*(( complex   *)PIN(0,DELAY)))

/*         
 *    OUTPUT BUFFER  DEFINES 
 */ 
#define outStream(delay) *( complex   *)POUT(0,delay)

/*         
 *    PARAMETER DEFINES 
 */ 
#define amplitudeMismatch (param_P[0]->value.f)
#define phaseMismatch (param_P[1]->value.f)
/*-------------- BLOCK CODE ---------------*/

iqimb
(run_state,block_P)

	int run_state;
	block_Pt block_P;
{
	param_Pt *param_P = block_P->param_AP;
	star_Pt star_P = block_P->star_P;

     
	state_Pt state_P = (state_Pt)star_P->state_P;
     
/*
 *              Declarations 
 */
 

  complex tmpIn;
  complex iqout;
  complex tmpIP;
  complex tmpQP;


switch (run_state) {

 
 


 
case PARAM_INIT: 
    {
      int indexModel88 = block_P->model_index;
     char   *pdef0 = " Amplitude Mismatch(percent) ";
     char   *ptype0 = "float";
     char   *pval0 = "10.0";
     char   *pname0 = "amplitudeMismatch";
     char   *pdef1 = " Phase Mismatch(Deg) ";
     char   *ptype1 = "float";
     char   *pval1 = "2.0";
     char   *pname1 = "phaseMismatch";
KrnModelParam(indexModel88,0 ,pdef0,ptype0,pval0,pname0);
KrnModelParam(indexModel88,1 ,pdef1,ptype1,pval1,pname1);

      }
break;
   


/*         
 *    OUTPUT BUFFER SYSTEM  INITS 
 */ 
 case OUTPUT_BUFFER_INIT: 
 {
 int indexOC = block_P->model_index;
     char   *ptypeOut0 = " complex ";
     char   *pnameOut0 = " outStream ";
KrnModelConnectionOutput(indexOC,0 ,pnameOut0,ptypeOut0);
}
 break;

/*         
 *    INPUT BUFFER SYSTEM  INITS 
 */ 
 case INPUT_BUFFER_INIT:
 {
 int indexIC = block_P->model_index;
     char   *ptypeIn0 = " complex ";
     char   *pnameIn0 = " inStream ";
KrnModelConnectionInput(indexIC,0 ,pnameIn0,ptypeIn0);
}
 break;

/*
 *        SYSTEM INITIALIZATION CODE 
 */
case SYSTEM_INIT:
     
	star_P->state_P = (char*)calloc(1,sizeof(state_t));
	state_P = (state_Pt)star_P->state_P;
     


         
   if(NO_OUTPUT_BUFFERS() != 1 ){
       fprintf(stdout,"%s:1 outputs expected; %d connected\n",
              STAR_NAME,NO_OUTPUT_BUFFERS());
	      return(201);
   }

   SET_CELL_SIZE_OUT(0,sizeof( complex ));

         
   if(NO_INPUT_BUFFERS() != 1 ){
       fprintf(stdout,"%s:1 inputs expected; %d connected\n",
              STAR_NAME,NO_INPUT_BUFFERS());
	      return(200);
   }

   SET_CELL_SIZE_IN(0,sizeof( complex ));

break;

/*
 *               USER INITIALIZATION CODE 
 */
case USER_INIT: 

 

  iampe = 1-0.5*amplitudeMismatch/100.;
  qampe = 1+0.5*amplitudeMismatch/100.;
  ipe.re = cos(-PI*phaseMismatch/360.);
  ipe.im = sin(-PI*phaseMismatch/360.);
  qpe.re = cos(PI*phaseMismatch/360.);
  qpe.im = sin(PI*phaseMismatch/360.);	


break;

/* 
 *             MAIN CODE 
 */
case MAIN_CODE: 

 


  while( AVAIL(0) ) {
    IT_IN(0);

	tmpIn = INCX(0,0);

	IA=tmpIn.re*iampe;
	QA=tmpIn.im*qampe;

	tmpIP.re=IA*ipe.re;
	tmpIP.im=IA*ipe.im;
	tmpQP.im=QA*qpe.re;
	tmpQP.re=-QA*qpe.im;
	
	iqout.re=tmpIP.re+tmpQP.re;
	iqout.im=tmpIP.im+tmpQP.im;

    if (IT_OUT(0)){
	   KrnOverflow("iqimb",0);
	   return(99);
    }

	OUTCX(0,0) = iqout;
  }



break;

/*             
 *            WRAPUP CODE 
 */
case WRAPUP: 

 



break;
}
return(0);
}
