<BLOCK>
<LICENSE>
/*
 * (c) 2007 XCAD Corporation, Portland, Oregon, All Rights Reserved.
 * Acknowledgement Dr. Yoon
 */


</LICENSE>
<BLOCK_NAME>
iqimb
</BLOCK_NAME> 

<COMMENTS>
<![CDATA[ 

]]>
</COMMENTS> 


<DESC_SHORT>
Model IQ imbalance specifying amplitude mismatch (percent) and phase (degrees).
</DESC_SHORT>

<INCLUDES>
<![CDATA[ 


]]>
</INCLUDES> 

<DEFINES> 

#define PI 3.1415926535898

</DEFINES> 

<DECLARATIONS> 

  complex tmpIn;
  complex iqout;
  complex tmpIP;
  complex tmpQP;

</DECLARATIONS> 




<STATES>
	<STATE>
		<TYPE> float </TYPE>
		<NAME> IA </NAME>
	</STATE>
	<STATE>
		<TYPE> float </TYPE>
		<NAME> QA </NAME>
	</STATE>
	<STATE>
		<TYPE> float </TYPE>
		<NAME> iampe </NAME>
	</STATE>
	<STATE>
		<TYPE> float </TYPE>
		<NAME> qampe </NAME>
	</STATE>
	<STATE>
		<TYPE> complex </TYPE>
		<NAME> ipe </NAME>
	</STATE>
	<STATE>
		<TYPE> complex </TYPE>
		<NAME> qpe </NAME>
	</STATE>
</STATES>



<PARAMETERS>
	<PARAM>
		<DEF> Amplitude Mismatch(percent) </DEF>
		<TYPE> float </TYPE>
		<NAME> amplitudeMismatch </NAME>
		<VALUE> 10.0 </VALUE>
	</PARAM>
	<PARAM>
		<DEF> Phase Mismatch(Deg) </DEF>
		<TYPE> float </TYPE>
		<NAME> phaseMismatch </NAME>
		<VALUE> 2.0 </VALUE>
	</PARAM>
</PARAMETERS>



<INPUT_BUFFERS>
	<BUFFER>
		<TYPE> complex </TYPE>
		<NAME> inStream </NAME>
	</BUFFER>
</INPUT_BUFFERS>



<OUTPUT_BUFFERS>
	<BUFFER>
		<TYPE> complex </TYPE>
		<NAME> outStream </NAME>
	</BUFFER>
</OUTPUT_BUFFERS>

<INIT_CODE>
<![CDATA[ 

  iampe = 1-0.5*amplitudeMismatch/100.;
  qampe = 1+0.5*amplitudeMismatch/100.;
  ipe.re = cos(-PI*phaseMismatch/360.);
  ipe.im = sin(-PI*phaseMismatch/360.);
  qpe.re = cos(PI*phaseMismatch/360.);
  qpe.im = sin(PI*phaseMismatch/360.);	

]]>
</INIT_CODE> 


<MAIN_CODE>
<![CDATA[ 


  while( AVAIL(0) ) {
    IT_IN(0);

	tmpIn = INCX(0,0);

	IA=tmpIn.re*iampe;
	QA=tmpIn.im*qampe;

	tmpIP.re=IA*ipe.re;
	tmpIP.im=IA*ipe.im;
	tmpQP.im=QA*qpe.re;
	tmpQP.re=-QA*qpe.im;
	
	iqout.re=tmpIP.re+tmpQP.re;
	iqout.im=tmpIP.im+tmpQP.im;

    if (IT_OUT(0)){
	   KrnOverflow("iqimb",0);
	   return(99);
    }

	OUTCX(0,0) = iqout;
  }


]]>
</MAIN_CODE> 

<WRAPUP_CODE>
<![CDATA[ 


]]>
</WRAPUP_CODE> 



</BLOCK> 

