 
#ifdef LICENSE

/*
 * (c) XCAD  Corporation, Portland, Oregon, All Rights Reserved
 */


#endif
 
#ifdef SHORT_DESCRIPTION

Models non linear amplifiers (e.g. TWT) with AM-AM and AM-PM.

#endif
 
#ifdef PROGRAMMERS

#endif






#include <stdio.h>
#include <math.h>

/* Note: these paths are installation dependent! */
#include <capsim.h>
#include <stars.h>



/*
 *           STATES STRUCTURE 
 */ 
typedef struct {
       int   __stateVariable;
     } state_t,*state_Pt;

/*
 *         STATE DEFINES 
 */ 
#define  stateVariable  (state_P->__stateVariable)

/*         
 *    INPUT BUFFER DEFINES 
 */ 
#define r(DELAY) (*(( float   *)PIN(0,DELAY)))
#define scos(DELAY) (*(( float   *)PIN(1,DELAY)))
#define ssin(DELAY) (*(( float   *)PIN(2,DELAY)))

/*         
 *    OUTPUT BUFFER  DEFINES 
 */ 
#define y(delay) *( float   *)POUT(0,delay)

/*         
 *    PARAMETER DEFINES 
 */ 
#define alphaA (param_P[0]->value.f)
#define betaA (param_P[1]->value.f)
#define alphaPhi (param_P[2]->value.f)
#define betaPhi (param_P[3]->value.f)
/*-------------- BLOCK CODE ---------------*/

nonlinsaleh
(run_state,block_P)

	int run_state;
	block_Pt block_P;
{
	param_Pt *param_P = block_P->param_AP;
	star_Pt star_P = block_P->star_P;

     
	state_Pt state_P = (state_Pt)star_P->state_P;
     
/*
 *              Declarations 
 */
 

   	int i,k;
   	double sgcos;
	double sgsin;
	double sample;
        double rs;
        double Ar;
        double Phir;
        double Pr;
        double Qr;


switch (run_state) {

 
 


 
case PARAM_INIT: 
    {
      int indexModel88 = block_P->model_index;
     char   *pdef0 = " alphaA ";
     char   *ptype0 = "float";
     char   *pval0 = "1.0";
     char   *pname0 = "alphaA";
     char   *pdef1 = " betaA ";
     char   *ptype1 = "float";
     char   *pval1 = "0.0";
     char   *pname1 = "betaA";
     char   *pdef2 = " alphaPhi ";
     char   *ptype2 = "float";
     char   *pval2 = "0.0";
     char   *pname2 = "alphaPhi";
     char   *pdef3 = " betaPhi ";
     char   *ptype3 = "float";
     char   *pval3 = "0.0";
     char   *pname3 = "betaPhi";
KrnModelParam(indexModel88,0 ,pdef0,ptype0,pval0,pname0);
KrnModelParam(indexModel88,1 ,pdef1,ptype1,pval1,pname1);
KrnModelParam(indexModel88,2 ,pdef2,ptype2,pval2,pname2);
KrnModelParam(indexModel88,3 ,pdef3,ptype3,pval3,pname3);

      }
break;
   


/*         
 *    OUTPUT BUFFER SYSTEM  INITS 
 */ 
 case OUTPUT_BUFFER_INIT: 
 {
 int indexOC = block_P->model_index;
     char   *ptypeOut0 = " float ";
     char   *pnameOut0 = " y ";
KrnModelConnectionOutput(indexOC,0 ,pnameOut0,ptypeOut0);
}
 break;

/*         
 *    INPUT BUFFER SYSTEM  INITS 
 */ 
 case INPUT_BUFFER_INIT:
 {
 int indexIC = block_P->model_index;
     char   *ptypeIn0 = " float ";
     char   *pnameIn0 = " r ";
     char   *ptypeIn1 = " float ";
     char   *pnameIn1 = " scos ";
     char   *ptypeIn2 = " float ";
     char   *pnameIn2 = " ssin ";
KrnModelConnectionInput(indexIC,0 ,pnameIn0,ptypeIn0);
KrnModelConnectionInput(indexIC,1 ,pnameIn1,ptypeIn1);
KrnModelConnectionInput(indexIC,2 ,pnameIn2,ptypeIn2);
}
 break;

/*
 *        SYSTEM INITIALIZATION CODE 
 */
case SYSTEM_INIT:
     
	star_P->state_P = (char*)calloc(1,sizeof(state_t));
	state_P = (state_Pt)star_P->state_P;
             stateVariable = 0 ;



         
   if(NO_OUTPUT_BUFFERS() != 1 ){
       fprintf(stdout,"%s:1 outputs expected; %d connected\n",
              STAR_NAME,NO_OUTPUT_BUFFERS());
	      return(201);
   }

   SET_CELL_SIZE_OUT(0,sizeof( float ));

         
   if(NO_INPUT_BUFFERS() != 3 ){
       fprintf(stdout,"%s:3 inputs expected; %d connected\n",
              STAR_NAME,NO_INPUT_BUFFERS());
	      return(200);
   }

   SET_CELL_SIZE_IN(0,sizeof( float ));

   SET_CELL_SIZE_IN(1,sizeof( float ));

   SET_CELL_SIZE_IN(2,sizeof( float ));

break;

/*
 *               USER INITIALIZATION CODE 
 */
case USER_INIT: 

 



break;

/* 
 *             MAIN CODE 
 */
case MAIN_CODE: 

 




for(k=(MIN_AVAIL());k >0; --k) {
       IT_IN(0);
       IT_IN(1);
       IT_IN(2);
       
       
       rs=r(0);
       sgcos=scos(0);
       sgsin=ssin(0);
       
       Ar=alphaA*rs/(1+betaA*rs*rs);
       Phir=alphaPhi*rs*rs/(1+betaPhi*rs*rs);
       Pr=Ar*cos(Phir);
       Qr=Ar*sin(Phir);
       
       sample=Pr*sgcos-Qr*sgsin;
       
  
       
   	   /*
	    * ready output buffer for sample
	    * check for overflow
	    */
	   if(IT_OUT(0)) {
				KrnOverflow("nonlinsaleh",0);
				return(99);
	   }
	   /*
	    * output the sample
	    */
	   y(0)=sample;


}
    


break;

/*             
 *            WRAPUP CODE 
 */
case WRAPUP: 

 



break;
}
return(0);
}
