<BLOCK>
<LICENSE>
/*
 * (c) XCAD  Corporation, Portland, Oregon, All Rights Reserved
 */

</LICENSE>
<BLOCK_NAME>
nonlinsaleh
</BLOCK_NAME> 


<DESC_SHORT>
Models non linear amplifiers (e.g. TWT) with AM-AM and AM-PM.
</DESC_SHORT>

<COMMENTS>
<![CDATA[ 

/*
 * 		nonlinsaleh()
 *
 * Generated by blockgen
 *
 * Models Nonlinear Amplifiers with AM-AM and AM-PM (TWT's)
 *
 * Reference:
 * Saleh, A., "Frequency-Independent and Frequency-Dependent Nonlinear Models of TWT Amplifiers
 * IEEE Transactions on Communications 
 * Volume 29,  Issue 11,  Date: Nov 1981,  Pages:  1715 - 1720
 *    
 * Programmer: Sasan Ardalan 
 * Date: June 27, 2007
 * Modified: 
 *
 */
]]>
</COMMENTS> 

<DECLARATIONS> 

   	int i,k;
   	double sgcos;
	double sgsin;
	double sample;
        double rs;
        double Ar;
        double Phir;
        double Pr;
        double Qr;

</DECLARATIONS> 

<PARAMETERS>
        <PARAM>
               <DEF> alphaA </DEF>
               <TYPE> float </TYPE>
               <NAME> alphaA </NAME>
               <VALUE> 1.0 </VALUE>
        </PARAM>
        <PARAM>
               <DEF> betaA </DEF>
               <TYPE> float </TYPE>
               <NAME> betaA </NAME>
               <VALUE> 0.0 </VALUE>
        </PARAM>
        <PARAM>
               <DEF> alphaPhi </DEF>
               <TYPE> float </TYPE>
               <NAME> alphaPhi </NAME>
               <VALUE> 0.0 </VALUE>
        </PARAM>
        <PARAM>
               <DEF> betaPhi </DEF>
               <TYPE> float </TYPE>
               <NAME> betaPhi </NAME>
               <VALUE> 0.0 </VALUE>
        </PARAM>
 
</PARAMETERS>


<STATES>
	<STATE>
		<TYPE> int </TYPE>
		<NAME> stateVariable </NAME>
		<VALUE> 0 </VALUE>
	</STATE>
</STATES>



<INPUT_BUFFERS>
	<BUFFER>
		<TYPE> float </TYPE>
		<NAME> r </NAME>
	</BUFFER>
	<BUFFER>
		<TYPE> float </TYPE>
		<NAME> scos </NAME>
	</BUFFER>
	<BUFFER>
		<TYPE> float </TYPE>
		<NAME> ssin </NAME>
	</BUFFER>
	
</INPUT_BUFFERS>



<OUTPUT_BUFFERS>
	<BUFFER>
		<TYPE> float </TYPE>
		<NAME> y </NAME>
	</BUFFER>
</OUTPUT_BUFFERS>

<INIT_CODE>
<![CDATA[ 


]]>
</INIT_CODE> 


<MAIN_CODE>
<![CDATA[ 




for(k=(MIN_AVAIL());k >0; --k) {
       IT_IN(0);
       IT_IN(1);
       IT_IN(2);
       
       
       rs=r(0);
       sgcos=scos(0);
       sgsin=ssin(0);
       
       Ar=alphaA*rs/(1+betaA*rs*rs);
       Phir=alphaPhi*rs*rs/(1+betaPhi*rs*rs);
       Pr=Ar*cos(Phir);
       Qr=Ar*sin(Phir);
       
       sample=Pr*sgcos-Qr*sgsin;
       
  
       
   	   /*
	    * ready output buffer for sample
	    * check for overflow
	    */
	   if(IT_OUT(0)) {
				KrnOverflow("nonlinsaleh",0);
				return(99);
	   }
	   /*
	    * output the sample
	    */
	   y(0)=sample;


}
    

]]>
</MAIN_CODE> 

<WRAPUP_CODE>
<![CDATA[ 


]]>
</WRAPUP_CODE> 



</BLOCK> 

