.po +0.5i
.nr pp 12
.nr sp 12
.nr tp 12
.nr qp 12
.nr fp 10
.fo ''%''
.(b C
.ps 14
.b "BLOSIM 3.6 Program Manager Manual"
.ps 12
.sp 2
L. James Faber
ECE Department
North Carolina State University
Raleigh, NC 27695
.sp 2
\*(td
.)b
.he 'BLOSIM 3.6 Program Manager Manual''\*(td'
.sp 2
.sh 1 "Introduction"
.lp
This manual is intended to explain the philosophy and operation
of the BLOSIM source code.
It has been heavily modified and hopefully improved and simplified
(by the author of this manual)
since the original package was received from Berkeley in November 1987.
These notes are intended for the person responsible for maintaining and
improving the BLOSIM source code, or anyone who is just curious.
To understand this material, the reader must be familiar with the
standard practices of C language coding,
including structures and pointers.
The manual is organized as follows:
.ip 1)
an overview of program operation
.ip 2)
a discussion of the organization of the source files.
.ip 3)
a discussion of the major functions.
.pp
An essential feature of Blosim is a uniform structure for each
node in a simulation tree.
This structure is called a BLOCK,
and is detailed in the include file blosim.h.
Each node element in a simulation is represented by a block,
and all blocks are connected via pointers into a hierarchical structure.
The hierarchical structure is organized as a tree.
The top (root) of the tree is a single block called the Universe block.
Each level of the tree is called a galaxy.
Each block (node) within a galaxy is connected to its sibling blocks
in a doubly linked (circular) list.
There are two types of blocks:
Galaxy blocks, which have another level below them (they have children),
or Star blocks, which can not have children.
Each block maintains a pointer to its parent block.
Each Galaxy block maintains a pointer to one of its child blocks.
The block types are distinquished by a code in their structure.
Note that the Universe block is also a Galaxy block.
A valid simulation tree always eventually terminates at Star blocks.
Placement of siblings within a galaxy is determined initially
by the order in which they are created.
The first block created within a galaxy is the 'child' and subsequent
blocks are connected as forward siblings.
Each block points to the galaxy block above as parent.
Note:  the ordering of blocks within a galaxy is modified for efficient
simulation during the running process.
This is discussed further below.
.pp
The other requirement for storing a simulation topology
is a record of required signal flow connections between blocks.
This information is also stored within each block.
There are two arrays of block pointers used to store
input connection blocks and output connection blocks.
Additionally, the appropriate port number for each connecting block
is also stored.
This structure represents a complete Blosim simulation topology.
