.sz 12
.po +1.1i
.ll 6.5i
.ls 1
.nr pp 12
.EQ
delim ##
gsize 12
.EN
.fo ''%''
.ps +2
.ft B
.ce
A Short Description of the Current Star Library
.sp
.ps
.ft
.po -.5i
.sp
add
.sp
.po +.5i
.ft 1
Function adds all its input samples to yield an
output sample; the number of input buffers is arbitrary and determined
at run time.
.lp
\f3Parameters:\f1 None
.sp
.ft 2
.po -.5i
.sp
fork
.sp
.po +.5i
.ft 1
Function has a single input buffer and puts out each input sample to
all its output buffers the number of which is determined at run time.
.lp
\f3Parameters:\f1 None
.sp
.ft 2
.po -.5i
data
.sp
.po +0.5i
.ft 1
Function generates a random sequence of bits
which can be used to exercise a data transmission system. The
pseudo-random sequence generator uses the polynomial
$x sup 10 ~+~x sup 3 ~+~1$.
.lp
\f3Parameters:\f1
.lp
1. Total length of the sequence to be generated (int).
.lp
2. A seed to initialize the shift register. Similar to the seed in
random number generation. (int).
.sp
.ft 2
.po -0.5i
delay
.sp
.po +0.5i
.ft 1
Function delays its input samples by specified number of
samples.
.lp
\f3Parameters:\f1
.lp
1. Number of samples of delay. No default. (int).
.sp
.ft 2
.po -0.5i
filtnyq
.sp
.po +0.5i
.ft 1
This star performs \f3Nyquist\f1 pulse shaping for a baseband
transmitter.  See \f3Carlson, Communications Systems,\f1 page 381.
The filter impulse response is time limited to 12 baud intervals.
The input data is assumed to be oversampled at a rate which is specified
by the first input parameter.
.lp
\f3Parameters:\f1
.lp
1. Oversampling rate of the input data (int).
.lp
2. The length of the FFT to be used, with $2 sup parameter_2 $ the
FFT length (int).
.lp
3. The filter rolloff rate in the frequency domain; 0 < $beta$ <= .5
.sp
.ft 2
.po -0.5i
impulse
.sp
.po +0.5i
.ft 1
This star sends out a unit sample followed by a specified number of zero samples.
.lp
\f3Parameters:\f1
.lp
1. Total number of samples to be send out (int).
.sp
.ft 2
.po -0.5i
lconv
.sp
.po +0.5i
.ft 1
This star convolves its input signal with an impulse response to
generate the output signal.
Convolution is performed by the overlap-save method
(\f3Oppenheim & Schafer, Digital Signal Processing,\f1 pp. 113).
The FFT length must be greater than the impulse response length.
.lp
\f3Parameters:\f1
.lp
1. The impulse response length (int).
.lp
2. Name of the ASCII file which contains the impulse response
sequence (file).
.lp
3. The length of the FFT to be used, with $2 sup parameter_3 $ the
FFT length (int).
.sp
.ft 2
.po -0.5i
linecode
.sp
.po +0.5i
.ft 1
This star inputs binary data and outputs various line codes.
Line codes are selectable by the first input parameter:
.(b
	0 - Binary (1 = +1, 0 = -1)  (Default; 1 phase)
	1 - Biphase (1 = -1,+1)  (2 phase)
	2 - WAL2  (1 = -1,+1,+1,-1)  (4 phase)
.)b
The code output oversampling rate (samples per baud interval) is
selected by the second parameter.  Note that the multi-phase
codes require oversampling rates which are integer multiples of the
number of phases!
I/O buffers are float to be compatible with most stars.
.lp
\f3Parameters:\f1
.lp
1. Code type selector (int).
.lp
2. Oversampling rate (int).
.sp
.ft 2
.po -0.5i
multiply
.sp
.po +0.5i 
.ft 1
This star takes as a parameter a coefficient, multiplies the incoming
data stream by the coefficient, and puts it on the output stream.
.lp
\f3Parameters:\f1
.lp
1. Coefficient (float)
.sp
.ft 2
.po -0.5i
null
.sp
.po +0.5i
.ft 1
This star does nothing, simply puts its input samples on its output
buffer. It is useful as a temporary substitute for a star.
.lp
\f3Parameters:\f1 None
.sp
.ft 2
.po -0.5i
print_file
.sp
.po +0.5i
.ft 1
Function prints samples from an arbitrary number of input buffers
to a file, the name of which is passed as a parameter (one sample from
each input is printed on each line). The file, when not specified,
defaults to standard output. This routine does not print the time axis;
to obtain the time axis, the user should connect the block time() to
input #0.
.lp
\f3Parameters:\f1
.lp
1. Output file name (file).
.sp
.ft 2
.po -0.5i
read_file
.sp
.po +0.5i
.ft 1
This function performs the simple task of reading
sample values in from a file, and then placing them on
it's output buffer. The file may have multiple sample values
per line, which can be integer or float. An example of a use for
this routine is to access a stored waveform as input to a simulation.
.lp
\f3Parameters:\f1
.lp
1. Input file name (defaults to "stdin")(file).
.sp
.ft 2
.po -0.5i
time
.sp
.po +0.5i
.ft 1
Function outputs the time to a single output fifo. The time between
samples and the time before stopping are both input parameters. The
time between samples defaults to 1.0 sec. The time before stopping
defaults to infinity. Using the stopping criterion is a convenient way
of controlling the length of the simulation to a certain time interval
specified in seconds.
.lp
\f3Parameters:\f1
.lp
1. The time between samples (float).
.lp
2. Stopping time (float).
.sp
.ft 2
.po -0.5i
zero
.sp
.po +0.5i
.ft 1
This star sends out a number of zero samples. The only parameter,
which defaults to NOSAMPLES, tells how many zero samples to send out.
.lp
\f3Parameters:\f1
.lp
1. Number of samples (int).
