/* 
 * krn_args.h
 *
 * global declarations for qplot library
 *
 * Authors:
 * Dr. Sasan H. Ardalan

 *
 * Copyright 1988 by Sasan H. Ardalan.  All rights reserved.  Do not remove this notice.
 */


/*
 * Object structure.  Holds object data.
 * Objects  are held in a circular list.  The list_P member of the header
 * points to the "last" object in the list; the next node is a sentinel with
 * sentFlag == TRUE, and the next node is the "first" object in the list.
 *
 * Linked List to hold argument  objects together
 */

typedef struct krn_argObj {

	param_Pt	parameters_P;
	int		argNumber;
	int		key;
	
	unsigned int	
     	tagFlag : 1,	/* whether tagged 		*/
		sentFlag : 1;	/* this node is a sentinel 		*/
		
	
	struct krn_argObj		*next_P;   /* ptr to next entry.*/

} krn_ArgObj_t, *krn_ArgObj_Pt;



/*
 *  Header for macro object list.
 */

typedef struct {
	int			num;		/* number of objects	*/


	krn_ArgObj_Pt		list_P;		/* ptr to last object in*/
						/*   circular list	*/
} krn_ArgHdr_t, *krn_ArgHdr_Pt;







