
/* krn_stars.h */
/**********************************************************************

		INCLUDE FILE FOR STARS

**********************************************************************

This file should be included in all CAPSIM user star routines --
It defines macro substitutions
*/

typedef struct {
	float	re;
	float	im;
} complex;

typedef struct {
	long int	lowWord;
	long int	highWord;
} doublePrecInt;

typedef struct {
	int		width;
	int		height;
	float** 	image_PP; 
} image_t, *image_Pt;

POINTER buffer_add(),buffer_access();

#define avail(BUFFER_NO) \
	buffer_length(pstar->pin_buffer[BUFFER_NO])

#define min_avail() minimum_samples(pstar)

#define it_in(BUFFER_NO) \
	 inc_rd_ptr(pstar->pin_buffer[BUFFER_NO])

#define pin(BUFFER_NO,DELAY) \
	 buffer_access(pstar->pin_buffer[BUFFER_NO],1,DELAY)

#define inf(BUFFER_NO,DELAY) \
	 *(float *)buffer_access(pstar->pin_buffer[BUFFER_NO],1,DELAY)

#define ini(BUFFER_NO,DELAY) \
	 *(int *)buffer_access(pstar->pin_buffer[BUFFER_NO],1,DELAY)

#define inc(BUFFER_NO,DELAY) \
	 *(char *)buffer_access(pstar->pin_buffer[BUFFER_NO],1,DELAY)

#define ind(BUFFER_NO,DELAY) \
	 *(double *)buffer_access(pstar->pin_buffer[BUFFER_NO],1,DELAY)

#define incx(BUFFER_NO,DELAY) \
	 *(complex *)buffer_access(pstar->pin_buffer[BUFFER_NO],1,DELAY)

#define indi(BUFFER_NO,DELAY) \
	 *(doublePrecInt *)buffer_access(pstar->pin_buffer[BUFFER_NO],1,DELAY)

#define inimage(BUFFER_NO,DELAY) \
	 *(image_t *)buffer_access(pstar->pin_buffer[BUFFER_NO],1,DELAY)

#define it_out(BUFFER_NO) \
	inc_wr_ptr(pstar->pout_buffer[BUFFER_NO])

#define pout(BUFFER_NO,DELAY) \
	 buffer_access(pstar->pout_buffer[BUFFER_NO],0,DELAY)


#define outf(BUFFER_NO,DELAY) \
	 *(float *)buffer_access(pstar->pout_buffer[BUFFER_NO],0,DELAY)

#define outi(BUFFER_NO,DELAY) \
	 *(int *)buffer_access(pstar->pout_buffer[BUFFER_NO],0,DELAY)

#define outc(BUFFER_NO,DELAY) \
	 *(char *)buffer_access(pstar->pout_buffer[BUFFER_NO],0,DELAY)

#define outd(BUFFER_NO,DELAY) \
	 *(double *)buffer_access(pstar->pout_buffer[BUFFER_NO],0,DELAY)

#define outcx(BUFFER_NO,DELAY) \
	 *(complex *)buffer_access(pstar->pout_buffer[BUFFER_NO],0,DELAY)

#define outdi(BUFFER_NO,DELAY) \
	 *(doublePrecInt *)buffer_access(pstar->pout_buffer[BUFFER_NO],0,DELAY)

#define outimage(BUFFER_NO,DELAY) \
	 *(image_t *)buffer_access(pstar->pout_buffer[BUFFER_NO],0,DELAY)

#define sname(BUFFER_NO)  (pstar->sig_name[BUFFER_NO])

#define set_dmin_in(BUFFER_NO,DELAY) \
	 delay_min(pstar->pin_buffer[BUFFER_NO],DELAY)

#define set_dmax_in(BUFFER_NO,DELAY) \
	 delay_max(pstar->pin_buffer[BUFFER_NO],DELAY)

#define set_dmax_out(BUFFER_NO,DELAY) \
	 delay_max(pstar->pout_buffer[BUFFER_NO],DELAY)

#define set_cellsize_in(BUFFER_NO,SIZE) \
	 cellsize(pstar->pin_buffer[BUFFER_NO],SIZE)

#define set_cellsize_out(BUFFER_NO,SIZE) \
	 cellsize(pstar->pout_buffer[BUFFER_NO],SIZE)

#define no_output_buffers()	(pstar->out_buffers)

#define no_input_buffers()	(pstar->in_buffers)


/* the following are for examination of the buffers during debugging */
#define look_out(BUFFER_NO) \
	examine_buffer(pstar->pout_buffer[BUFFER_NO])

#define look_in(BUFFER_NO) \
	examine_buffer(pstar->pin_buffer[BUFFER_NO])

extern double drand48();
