/*
 *  "Hello, world!" demonstration program
 *
 *  Copyright (C) 2006  Christophe Devine
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License, version 2.1 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *  MA  02110-1301  USA
 */

#ifndef _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_DEPRECATE 1
#endif

#ifdef _MSC_VER
#pragma comment(lib, "xyssl.lib")
#endif

#include <stdio.h>
#include <sys/stat.h>

#include "md5.h"

int main( void )
{
    int i;
    uchar digest[16];
    uchar str[] = "Hello, world!";
    struct stat fileStat;
    int err;
    FILE *fp;
    uchar *buffer_P;
    long fileSize;
    long bytesRead;
    static char *refdigest="b632bcdbe7bc548337efe06c1180f4e5";
    uchar digestRef[16];
    char theByte[100];
    uchar  c;

    printf("Ref =%s\n",refdigest);

    for(i=0; i< 16; i++) {
        theByte[0]=refdigest[2*i];
        theByte[1]=refdigest[2*i+1];
        theByte[3]=0;
//printf("theByte=%s\n",theByte);
        sscanf(theByte,"%x",&c);
        digestRef[i]= c;
        printf( "%02x", digestRef[i] );


    }
    printf( "\n\n" );

    printf( "\n  MD5('%s') = ", str );

    md5_csum( str, 13, digest );

    for( i = 0; i < 16; i++ )
        printf( "%02x", digest[i] );

    printf( "\n\n" );

    err=stat("zz.class",&fileStat);
    if( err != 0) return 0;
    
    printf("File size= %d\n",fileStat.st_size);
    fileSize=fileStat.st_size;

    fp=fopen("zz.class","r");
    if(fp==NULL) {
         fprintf(stderr,"Could not open file\n");
         return(0);
    }
    buffer_P=(uchar *) calloc(fileSize,sizeof(uchar));
    if(buffer_P==NULL) {
                  fprintf(stderr,"Could not allocate space\n");
                  return(0);
    }
    bytesRead=fread(buffer_P,1, fileSize, fp);
    if(bytesRead==0) {
                  fprintf(stderr,"Could not read in file\n");
                  return(0);

    }
    if(bytesRead!=fileSize) {
                  fprintf(stderr,"File size mismatch read was:%d\n",bytesRead);
                  return(0);

    }
//    printf ("SUCCESS!\n"); 
    printf( "\n  MD5() = ");
    md5_csum( buffer_P, fileSize, digest );


    for( i = 0; i < 16; i++ )
        printf( "%02x", digest[i] );
    printf( "\n\n" );

    for( i = 0; i < 16; i++ ) {
           if(digest[i] != digestRef[i]) {
               fprintf(stderr,"MISMATCH \n");
               return 0;
           }
    }
    printf ("SUCCESS!\n"); 

#ifdef WIN32
    printf( "  Press Enter to exit this program.\n" );
    fflush( stdout ); getchar();
#endif

    return( 0 );
}


