

/*
 *  HAVEGE: HArdware Volatile Entropy Gathering and Expansion
 *
 *  Copyright (C) 2006  Andre Seznec, Olivier Rochecouste
 *
 *  Contact: seznec(at)irisa_dot_fr - orocheco(at)irisa_dot_fr
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License, version 2.1 as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *  MA  02110-1301  USA
 */
/*
 *  The HAVEGE RNG was designed by Andre Seznec in 2002.
 *
 *  http://www.irisa.fr/caps/projects/hipsor/publi.php
 */

#ifndef _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_DEPRECATE 1
#endif


#define RAND_TEST

#include <string.h>
#include <stdio.h>
#include <time.h>

#include "timing.h"
#include "havege.h"

#ifdef RAND_TEST

#include <time.h>

int main( int argc, char *argv[] )
{
    FILE *f;
    time_t t;
    int i, j, k;
    ulong buf[1024];
    havege_state hs;

    char strBuf[100];

    if( argc < 2 )
    {
        fprintf( stderr, "usage: %s <output filename>\n", argv[0] );
        return( 1 );
    }

    if( ( f = fopen( argv[1], "wb+" ) ) == NULL )
    {
        fprintf( stderr, "failed to open '%s' for writing.\n", argv[0] );
        return( 1 );
    }

    havege_init( &hs );

    t = time( NULL );

//    for( i = 0, k = 32768 / sizeof( ulong ); i < k; i++ )
    for( i = 0, k = 2; i < k; i++ )
    {
        for( j = 0; j < 1024; j++ )
            buf[j] = havege_rand( &hs );
            

        for( j = 0; j < 1024; j++ ) {
            // fprintf(stdout,"%d \n",buf[j]);
            sprintf(strBuf,"%x \n",buf[j]);
            fprintf(stdout,"%s \n",strBuf);
        }

        fwrite( buf, sizeof( buf ), 1, f );

        printf( "Generating 32Mb of data in file '%s'... %04.1f" \
                "%% done\r", argv[1], (100 * (float) (i + 1)) / k );
        fflush( stdout );
    }

    if( t == time( NULL ) )
        t--;

    printf( "Generating 32Mb of data in file '%s'... done (%ld bytes/" \
            "sec)\n", argv[1], ( 32 * 1048576 ) / ( time( NULL ) - t ) );

    fclose( f );
    return( 0 );
}
#endif
